'+--------------------------------------------------------------------------+
'|                               Settings                                   |
'|                                                                          |
'|                      GDImage media tuning controls                       |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                                                                          |
'|                         Author Patrice TERRIER                           |
'|                            copyright(c) 2014                             |
'|                           www.zapsolution.com                            |
'|                         support@zapsolution.com                          |
'|                                                                          |
'+--------------------------------------------------------------------------+
'|                  Project started on : 06-29-2014 (MM-DD-YYYY)            |
'|                        Last revised : 08-09-2014 (MM-DD-YYYY)            |
'+--------------------------------------------------------------------------+

#COMPILE EXE "Settings.exe"

%WINAPI                = 1
%TRUE                  = 1
%FALSE                 = 0
%NULL                  = 0
%IDC_ARROW             = 32512&
%COLOR_WINDOW          = 5
%INVALID_HANDLE_VALUE  = &HFFFFFFFF???
                       
%ERROR_ALREADY_EXISTS  = 183&
%SW_RESTORE            = 9
%WM_DESTROY            = &H2
%WM_SIZE               = &H5
%WM_PAINT              = &HF
%WM_MOUSEMOVE          = &H200
%WM_TIMER              = &H113
%WM_CLOSE              = &H10
%WM_COMMAND            = &H111
%WM_LBUTTONDOWN        = &H201
%WM_RBUTTONDOWN        = &H204
%WM_GETMINMAXINFO      = &H24
%WM_ERASEBKGND         = &H14
%WM_HSCROLL            = &H114
%WM_VSCROLL            = &H115
%WM_NOTIFY             = &H4E
                       
%SB_THUMBPOSITION      = 4
                       
%WS_POPUP              = &H80000000
%WS_CHILD              = &H40000000
%WS_VISIBLE            = &H10000000
%WS_CLIPSIBLINGS       = &H04000000
%WS_CLIPCHILDREN       = &H02000000
%WS_CAPTION            = &H00C00000  '// WS_BORDER or WS_DLGFRAME
%WS_SYSMENU            = &H00080000
%WS_THICKFRAME         = &H00040000
%WS_MINIMIZEBOX        = &H00020000
%WS_MAXIMIZEBOX        = &H00010000
                       
%CS_VREDRAW            = &H1
%CS_HREDRAW            = &H2
                       
%PM_REMOVE             = &H0001
%SM_CXSCREEN           = 0
%SM_CYSCREEN           = 1
%MAX_PATH              = 260

%LBN_SELCHANGE         = 1
%BN_CLICKED            = 0
%GENERIC_WRITE         = &H40000000&
%CREATE_ALWAYS         = 2
%FILE_ATTRIBUTE_NORMAL = &H00000080
%GENERIC_READ          = &H80000000&
%OPEN_ALWAYS           = 4

type NMHDR
    hwndFrom as DWORD
    idfrom as DWORD
    code as long '// used for messages, so needs to be LONG, not DWORD...
end type

type RECT
    nLeft as long
    nTop as long
    nRight as long
    nBottom as long
end type

type POINT
    x as long
    y as long
end type

type tagMSG DWORD
   hwnd    as DWORD   ' HWND
   message as DWORD   ' UINT
   wParam  as DWORD   ' WPARAM
   lParam  as long    ' LPARAM
   time    as DWORD   ' DWORD
   pt      as POINT   ' POINT
end type

type SECURITY_ATTRIBUTES
    nLength as DWORD
    lpSecurityDescriptor as long
    bInheritHandle as long
end type

type WNDCLASSEX
    cbSize as DWORD
    style as DWORD
    lpfnWndProc as long
    cbClsExtra as long
    cbWndExtra as long
    hInstance as DWORD
    hIcon as DWORD
    hCursor as DWORD
    hbrBackground as DWORD
    lpszMenuName as asciiz PTR
    lpszClassName as asciiz PTR
    hIconSm as DWORD
end type

type MINMAXINFO
    ptReserved as POINTAPI
    ptMaxSize as POINTAPI
    ptMaxPosition as POINTAPI
    ptMinTrackSize as POINTAPI
    ptMaxTrackSize as POINTAPI
end type

type FILETIME
    dwLowDateTime as DWORD
    dwHighDateTime as DWORD
end type

type WIN32_FIND_DATA
    dwFileAttributes as DWORD
    ftCreationTime as FILETIME
    ftLastAccessTime as FILETIME
    ftLastWriteTime as FILETIME
    nFileSizeHigh as DWORD
    nFileSizeLow as DWORD
    dwReserved0 as DWORD
    dwReserved1 as DWORD
    cFileName as asciiz * %MAX_PATH
    cAlternateFileName as asciiz * 14
end type

type SECURITY_ATTRIBUTES
    nLength as DWORD
    lpSecurityDescriptor as long
    bInheritHandle as long
end type

type OVERLAPPED
    Internal as DWORD
    InternalHigh as DWORD
    offset as DWORD
    OffsetHigh as DWORD
    hEvent as DWORD
end type

type OPENFILENAME
    lStructSize       as DWORD
    hWndOwner         as DWORD
    hInstance         as DWORD
    lpstrFilter       as asciiz PTR
    lpstrCustomFilter as asciiz PTR
    nMaxCustFilter    as DWORD
    nFilterIndex      as DWORD
    lpstrFile         as asciiz PTR
    nMaxFile          as DWORD
    lpstrFileTitle    as asciiz PTR
    nMaxFileTitle     as DWORD
    lpstrInitialDir   as asciiz PTR
    lpstrTitle        as asciiz PTR
    Flags             as DWORD
    nFileOffset       as WORD
    nFileExtension    as WORD
    lpstrDefExt       as asciiz PTR
    lCustData         as long
    lpfnHook          as DWORD
    lpTemplateName    as asciiz PTR
end type

type SYSTEMTIME
   wYear         as WORD
   wMonth        as WORD
   wDayOfWeek    as WORD
   wDay          as WORD
   wHour         as WORD
   wMinute       as WORD
   wSecond       as WORD
   wMilliseconds as WORD
end type

type FILETIME
    dwLowDateTime as DWORD
    dwHighDateTime as DWORD
end type

%OFN_EXPLORER         = &H00080000???
%OFN_FILEMUSTEXIST    = &H00001000???

%LB_ADDSTRING         = &H180
%LB_INSERTSTRING      = &H181
%LB_FINDSTRING        = &H18F
%LB_GETTEXT           = &H189
%LB_GETTEXTLEN        = &H18A
%LB_DELETESTRING      = &H182
%LB_RESETCONTENT      = &H184
%LB_SETCURSEL         = &H186
%LB_GETCURSEL         = &H188
%LB_GETCOUNT          = &H18B
%LBS_SORT             = &H2&

%SND_FILENAME         = &H00020000???
%SND_ASYNC            = &H0001???

declare sub      PostQuitMessage lib "USER32.DLL" alias "PostQuitMessage" (byval nExitCode as long)
declare function IsWindowVisible lib "USER32.DLL" alias "IsWindowVisible" (byval hWnd as DWORD) as long     
declare function GetWindowText lib "USER32.DLL" alias "GetWindowTextA" (byval hWnd as DWORD, lpString as asciiz, byval cch as long) as long
declare function GetFileTime lib "KERNEL32.DLL" alias "GetFileTime" (byval hFile as DWORD, byref lpCreationTime as FILETIME, byref lpLastAccessTime as FILETIME, byref lpLastWriteTime as FILETIME) as long 
declare function FileTimeToSystemTime lib "KERNEL32.DLL" alias "FileTimeToSystemTime" (lpFileTime AS FILETIME, lpSystemTime AS SYSTEMTIME) as long
declare function GetFileSize lib "KERNEL32.DLL" alias "GetFileSize" (byval hFile AS DWORD, byref lpFileSizeHigh as long) as DWORD  
declare function GetOpenFileName lib "COMDLG32.DLL" alias "GetOpenFileNameA" (lpofn as OPENFILENAME) as long
declare function GetProcAddress lib "KERNEL32.DLL" alias "GetProcAddress" (byval hModule as DWORD, lpProcName as asciiz) as long
declare function LoadLibrary lib "KERNEL32.DLL" alias "LoadLibraryA" (lpLibFileName as asciiz) as long
declare function FreeLibrary LIB "KERNEL32.DLL" alias "FreeLibrary" (byval hLibModule as DWORD) as long
declare function GetTempPath lib "KERNEL32.DLL" alias "GetTempPathA" (byval nBufferLength as long, lpBuffer as asciiz) as long
declare function DeleteObject lib "GDI32.DLL" alias "DeleteObject" (byval hObject as DWORD) as long
declare function FindFirstFile lib "KERNEL32.DLL" alias "FindFirstFileA" (lpFileName as asciiz, lpFindFileData as WIN32_FIND_DATA) as long
declare function FindClose lib "KERNEL32.DLL" alias "FindClose" (byval hFindFile as DWORD) as long
declare function FindNextFile lib "KERNEL32.DLL" alias "FindNextFileA" (byval hFindFile as DWORD, lpFindFileData as WIN32_FIND_DATA) as long
declare function CharLowerA lib "USER32.DLL" alias "CharLowerA" (lpsz as asciiz) as DWORD
declare function SendMessageA lib "USER32.DLL" alias "SendMessageA" (byval hWnd as DWORD, byval dwMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function PlaySound lib "WINMM.DLL" ALIAS "PlaySoundA" (pszSound as asciiz, byval hmod as DWORD, byval fdwSound as DWORD) as long
declare function GetParent lib "USER32.DLL" alias "GetParent" (byval hWnd as DWORD) as DWORD
declare function PostMessage lib "USER32.DLL" alias "PostMessageA" (byval hWnd as DWORD, byval dwMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function CopyFile lib "KERNEL32.DLL" alias "CopyFileA" (lpExistingFileName as asciiz, lpNewFileName as asciiz, byval bFailIfExists as long) as long
declare function AdjustWindowRectEx lib "USER32.DLL" alias "AdjustWindowRectEx" (lpRect as RECT, byval dsStyle as long, byval bMenu as long, byval dwEsStyle as DWORD) as long
declare function CreateFile lib "KERNEL32.DLL" alias "CreateFileA" (lpFileName as asciiz, byval dwDesiredAccess as DWORD, byval dwShareMode as DWORD, lpSecurityAttributes as SECURITY_ATTRIBUTES, _
                 byval dwCreationDisposition as DWORD, byval dwFlagsAndAttributes as DWORD, byval hTemplateFile as DWORD) as DWORD
declare function WriteFile lib "KERNEL32.DLL" alias "WriteFile" (byval hFile as DWORD, lpBuffer as any, byval nNumberOfBytesToWrite as DWORD, lpNumberOfBytesWritten as DWORD, lpOverlapped as OVERLAPPED) as long
declare function ReadFile lib "KERNEL32.DLL" ALIAS "ReadFile" (byval hFile as DWORD, lpBuffer as any, byval nNumberOfBytesToRead as DWORD, lpNumberOfBytesRead as DWORD, lpOverlapped as OVERLAPPED) as long
declare function CloseHandle lib "KERNEL32.DLL" alias "CloseHandle" (byval hObject as DWORD) as long
declare function CreateMutex lib "KERNEL32.DLL" alias "CreateMutexA" (lpMutexAttributes as SECURITY_ATTRIBUTES, byval bInitialOwner as long, lpName as asciiz) as long
declare function DefWindowProc lib "USER32.DLL" alias "DefWindowProcA" (byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
declare function DispatchMessage lib "USER32.DLL" alias "DispatchMessageA" (lpMsg as tagMSG) as long
declare function FindWindow lib "USER32.DLL" alias "FindWindowA" (lpClassName as asciiz, lpWindowName as asciiz) as long
declare function GetClassInfoEx lib "USER32.DLL" alias "GetClassInfoExA" (byval hInst as DWORD, lpszClass as asciiz, lpWndClass as WNDCLASSEX) as long
declare function GetClientRect lib "USER32.DLL" alias "GetClientRect" (byval hwnd as DWORD, lpRect as RECT) as long
declare function GetLastError lib "KERNEL32.DLL" alias "GetLastError" () as long
declare function GetMessage lib "USER32.DLL" alias "GetMessageA" (lpMsg as tagMSG, byval hWnd as DWORD, byval uMsgFilterMin as DWORD, byval uMsgFilterMax as DWORD) as long
declare function GetSystemMetrics lib "USER32.DLL" alias "GetSystemMetrics" (byval nIndex as long) as long
declare function IsIconic lib "USER32.DLL" alias "IsIconic" (byval hWnd as DWORD) as long
declare function LoadCursor lib "USER32.DLL" alias "LoadCursorA" (byval hInstance as DWORD, lpCursorName as asciiz) as DWORD
declare function LoadIcon lib "USER32.DLL" alias "LoadIconA" (byval hInstance as DWORD, lpIconName as asciiz) as DWORD
declare function PeekMessage lib "USER32.DLL" alias "PeekMessageA" (lpMsg as tagMSG, byval hWnd as DWORD, byval dwMsgFilterMin as DWORD, byval dwMsgFilterMax as DWORD, byval dwRemoveMsg as DWORD) as long
declare function RegisterClassEx lib "USER32.DLL" alias "RegisterClassExA" (pcWndClassEx as WNDCLASSEX) as WORD
declare function SetFocus lib "USER32.DLL" alias "SetFocus" (byval hWnd as DWORD) as long
declare function SetForegroundWindow lib "USER32.DLL" alias "SetForegroundWindow" (byval hWnd as DWORD) as long
declare function SetRect lib "USER32.DLL" alias "SetRect" (lpRect as RECT, byval X1 as long, byval Y1 as long, byval X2 as long, byval Y2 as long) as long
declare function ShowWindow lib "USER32.DLL" alias "ShowWindow" (byval hWnd as DWORD, byval nCmdShow as long) as long
declare function TranslateMessage lib "USER32.DLL" alias "TranslateMessage" (lpMsg as tagMSG) as long
declare function GetModuleFileName lib "KERNEL32.DLL" alias "GetModuleFileNameA" (byval hModule as DWORD, byref lpFilename as asciiz, byval nSize as DWORD) as DWORD
declare function PathCombine lib "SHLWAPI.DLL" alias "PathCombineA" (byref lpszDest as asciiz, byref lpszDir as asciiz, byref lpszFile as asciiz) as long
declare function zTrace lib "zTrace.DLL" alias "zTrace" (zMessage as asciiz) as long
declare function KillTimer lib "USER32.DLL" alias "KillTimer" (byval hWnd as DWORD, byval nIDEvent as long) as long
declare function SetTimer lib "USER32.DLL" alias "SetTimer" (byval hWnd as DWORD, byval nIDEvent as long, byval uElapse as DWORD, byval lpTimerFunc as long) as long
declare function CreateWindowExA lib "USER32.DLL" alias "CreateWindowExA" (byval dwStyleEx as DWORD, lpClassName as asciiz, lpWindowName as asciiz, byval dwStyle as DWORD, byval x as long, byval y as long, _
                                                                           byval nWidth as long, byval nHeight as long, byval hWndParent as DWORD, byval hMenu as DWORD, byval hInstance as DWORD, lpParam as ANY) as DWORD

#INCLUDE "gdimage.inc"

type STChannel
    ID          as long
    streamName  as asciiz * %MAX_PATH
    freq        as single
    volume      as single
    pan         as single
    mute        as byte
    solo        as byte
    duration    as long
    percent     as long
    grouplevel  as single
    led         as byte
    rMeterValue as single
    reserved    as asciiz * 25 '// Total 320 bytes.
end type

type SETBIN
    backsize as DWORD '// Size of the last background used
end type

type PROP
    hMain      as DWORD
    hList      as DWORD
    hlistback  as DWORD
    imagectrl  as DWORD
    hInstance  as DWORD
    winliftdll as DWORD
    focusID    as long
    pushID     as long
    overID     as long
    seedangle  as long
    prevangle  as long
    wasangle   as long
    playing    as long
    usechan    as long
    chanlength as QUAD
    szresource as asciiz * %MAX_PATH
    szsongpath as asciiz * %MAX_PATH
end type

GLOBAL gP as PROP, gBin as SETBIN

$SETFLY           = "setfly.bin"
$Comma            = ","
$FLYWLFT          = "&HFE005B,XCIREZGNZQJAKKUWQPFRTFCSVNAJCURNPDNCFSOESCRSIGSLDCTWCOBNLRZS"
%MAXCHANNEL       = 9

%ON               = 1
%OFF              = 2
%UP               = 1
%DOWN             = 2
%OPAQUEIMAGE      = &HFFFFFFFF
%HIGHLIGHT        = &HFF037BFA '// ZD_ARGB(255, 3,123,250)
%PLAYSOUND        = 1

%IDC_CTRL         = -1
%IDC_TIMER        = -2
%ClientWidth      = 825
%ClientHeight     = 592

'// Each sprite object must have a UNIQUE IDENTIFIER
%ID_BACKGROUND    = 500 + 1
%ID_LAYER_BOTTOM  = 500 + 2
%ID_LAYER_TOP     = 500 + 3
%ID_LIST_FRAME    = 500 + 4
%ID_LIST_TEXT     = 500 + 5
%ID_LIST_ARRANGE  = 500 + 6

%ID_MIX_ENABLE    = 500 + 7
%ID_DYN_ENABLE    = 500 + 8

%ID_PUSH_BUTTON   = 600
%ID_BTN_RESET     = %ID_PUSH_BUTTON + 1
%ID_BTN_APPLY     = %ID_PUSH_BUTTON + 2
%ID_BTN_SELECT    = %ID_PUSH_BUTTON + 3
%ID_BTN_PAUSE     = %ID_PUSH_BUTTON + 4
%ID_BTN_PLAY      = %ID_PUSH_BUTTON + 5

%ID_WIDGET        = 1000

%ID_BTN_SWITCH    = 100 + %ID_WIDGET
%ID_BTN_ACOUSTIC  = %ID_BTN_SWITCH
%ID_BTN_BASS      = %ID_BTN_SWITCH + 1
%ID_BTN_DRUM      = %ID_BTN_SWITCH + 2
%ID_BTN_GUITAR    = %ID_BTN_SWITCH + 3
%ID_BTN_KEY       = %ID_BTN_SWITCH + 4
%ID_BTN_PERC      = %ID_BTN_SWITCH + 5
%ID_BTN_PIANO     = %ID_BTN_SWITCH + 6
%ID_BTN_XTRACK    = %ID_BTN_SWITCH + 7

'//---------------------------------
%ID_GAUGE_BACK    = 200 + %ID_WIDGET
%ID_GAUGE_FRONT   = 210 + %ID_WIDGET
%ID_GAUGE_LIGHT   = 220 + %ID_WIDGET
%ID_GAUGE_LED     = 230 + %ID_WIDGET

%ID_TEMPO_BACK    = %ID_GAUGE_BACK
%ID_TEMPO_FRONT   = %ID_GAUGE_FRONT
%ID_TEMPO_LIGHT   = %ID_GAUGE_LIGHT
%ID_TEMPO_LED     = %ID_GAUGE_LED

%ID_GAIN_BACK     = %ID_GAUGE_BACK  + 1
%ID_GAIN_FRONT    = %ID_GAUGE_FRONT + 1
%ID_GAIN_LIGHT    = %ID_GAUGE_LIGHT + 1
%ID_GAIN_LED      = %ID_GAUGE_LED   + 1

%ID_VOL_BACK      = %ID_GAUGE_BACK  + 2
%ID_VOL_FRONT     = %ID_GAUGE_FRONT + 2
%ID_VOL_LIGHT     = %ID_GAUGE_LIGHT + 2
%ID_VOL_LED       = %ID_GAUGE_LED   + 2

%ID_FADE_BACK     = %ID_GAUGE_BACK  + 3
%ID_FADE_FRONT    = %ID_GAUGE_FRONT + 3
%ID_FADE_LIGHT    = %ID_GAUGE_LIGHT + 3
%ID_FADE_LED      = %ID_GAUGE_LED   + 3

%ID_VOL_BACK_UL   = %ID_GAUGE_BACK  + 4
%ID_VOL_FRONT_UL  = %ID_GAUGE_FRONT + 4
%ID_VOL_LIGHT_UL  = %ID_GAUGE_LIGHT + 4
%ID_VOL_LED_UL    = %ID_GAUGE_LED   + 4

%ID_FADE_BACK_UL  = %ID_GAUGE_BACK  + 5
%ID_FADE_FRONT_UL = %ID_GAUGE_FRONT + 5
%ID_FADE_LIGHT_UL = %ID_GAUGE_LIGHT + 5
%ID_FADE_LED_UL   = %ID_GAUGE_LED   + 5

'%ID_MAIN_VOLUME   = %ID_GAUGE_FRONT + 4

'//--------------------------------

%ID_TICK_BACK     = 300 + %ID_WIDGET
%ID_TICK_FRONT    = 310 + %ID_WIDGET
%ID_TICK_TEXT     = 320 + %ID_WIDGET
%ID_TICK_CHORD    = 330 + %ID_WIDGET
%ID_PITCH_BACK    = 300 + %ID_WIDGET
%ID_PITCH_FRONT   = 310 + %ID_WIDGET
%ID_PITCH_TEXT    = %ID_TICK_TEXT
%ID_PITCH_CHORD   = %ID_TICK_CHORD
%ID_DYNAMIC_BACK  = 301 + %ID_WIDGET
%ID_DYNAMIC_FRONT = 311 + %ID_WIDGET
%ID_DYNAMIC_TEXT  = 321 + %ID_WIDGET
%ID_DYNAMIC_CHORD = 331 + %ID_WIDGET

%ID_SLIDER_VERT   = 400 + %ID_WIDGET
%ID_THUMB_VERT    = 410 + %ID_WIDGET
%ID_SLIDER_LED    = 420 + %ID_WIDGET

%ID_SLIDER_HORZ   = 500 + %ID_WIDGET
%ID_THUMB_HORZ    = 510 + %ID_WIDGET
%ID_PROGRESS_HORZ = 520 + %ID_WIDGET

%ID_ARROW         = 2000
%ID_LARROW        = %ID_ARROW + 1
%ID_RARROW        = %ID_ARROW + 2

function FileSize(szFileSpec as asciiz) as DWORD
    local fd as WIN32_FIND_DATA
    local nRet, hFind as DWORD
    if (len(szFileSpec)) then
        hFind = FindFirstFile(szFileSpec, fd)
        if (hFind <> %INVALID_HANDLE_VALUE) then
            FindClose(hFind)
            nRet = fd.nFileSizeLow
        end if
    end if
    function = nRet
end function

sub ListDeleteAll(byval hList as DWORD)
    if hList then SendMessageA(hList, %LB_RESETCONTENT, 0, 0)
end sub

sub ListSelectPlus(byval hList as DWORD, byval nSelected as long)
    if nSelected > 0 then decr nSelected '// Because ListBox is zero based
    if hList then SendMessageA(hList, %LB_SETCURSEL, nSelected, 0)
end sub

function ListFindString(byval hList as DWORD, zTmp as asciiz) as long
    local nIndex as long
    nIndex = SendMessageA(hList, %LB_FINDSTRING, -1, VARPTR(zTmp))
    if nIndex > -1 then incr nIndex: function = nIndex
end function

function ListCount(byval hList as DWORD) as long
    if hList then function = SendMessageA(hList, %LB_GETCOUNT, 0, 0)
end function

function ListGetCursel(byval hList as DWORD) as long
    local nSelected as long
    if hList then
       nSelected = SendMessageA(hList, %LB_GETCURSEL, 0, 0)
       if nSelected > -1 then incr nSelected '// Because ListBox is zero based
    end if
    function = nSelected
end function

function ListAdd(byval hList as DWORD, zTmp as asciiz) as long
    if hList then
       if len(zTmp) then function = SendMessageA(hList, %LB_INSERTSTRING, -1, VARPTR(zTmp))
    end if
end function

function ListGetText(byval hList as DWORD, byval nItem as long) as string
    local sItem as string, nLen as long
    if nItem > 0 then
       decr nItem
       nLen = SendMessageA(hList, %LB_GETTEXTLEN, nItem, 0)
       sItem = SPACE$(nLen)
       SendMessageA(hList, %LB_GETTEXT, nItem, byval STRPTR(sItem))
       function = sItem
    end if
end function

sub ListDelete(byval hList as DWORD, byval nIndex as long)
    if nIndex > 0 then decr nIndex '// Because ListBox is zero based
    if hList then SendMessageA(hList, %LB_DELETESTRING, nIndex, 0)
end sub

sub ListInsert(byval hList as DWORD, byval nIndex as long, zTmp as asciiz)
    if nIndex > 0 then decr nIndex '// Because ListBox is zero based
    SendMessageA(hList, %LB_INSERTSTRING, nIndex, VARPTR(zTmp))
end sub

function sListMsg(byval UpDown as long) as string
    local sItem as string, nCount as long
    if UpDown = %DOWN then
        sItem = ListGetText(gP.hList, 1)
        ListDelete(gP.hList, 1)
        ListAdd(gP.hList, (sItem))
    elseif UpDown = %UP then
        sItem = ListGetText(gP.hList, ListCount(gP.hList))
        ListDelete(gP.hList, ListCount(gP.hList))
        ListInsert(gP.hList, 1, (sItem))
    end if
    sItem = ListGetText(gP.hList, 1) + $crlf + _
    ListGetText(gP.hList, 2) + $crlf + _
    ListGetText(gP.hList, 3) + $crlf + _
    ListGetText(gP.hList, 4) + $crlf + _
    ListGetText(gP.hList, 5)
    function = sItem
end function

function EXEpath() as string
    static szExepath as asciiz * %MAX_PATH
    if GetModuleFileName(0, szExepath, %MAX_PATH) then
        local K, nLen, nPos as long
        nLen = len(szExepath)
        nPos = nLen
        for K = 1 to nLen
            if ASC(szExepath, nPos - K) <> 92 then
                MID$(szExepath, nPos - K, 1) = CHR$(0)
            else
                exit for
            end if
        next
    end if
    function = szExepath
end function

function EXEresource() as string
    static szResource as asciiz * %MAX_PATH
    PathCombine(szResource, EXEpath(), "Resource\")
    function = szResource
end function

function TEMPpath() as string
    static szBuf as asciiz * %MAX_PATH
    local nSize as DWORD
    nSize = GetTempPath(GetTempPath(byval %NULL, byval %NULL), szBuf)
    function = szBuf
end function

sub DetectArrangement(byval sFullPathName as string)
    local K, nCount, nBackground as long
    gP.hList = CreateWindowExA(0, "LISTBOX", "", %WS_CHILD or %LBS_SORT, 0, 0, 0, 0, gP.hMain, 0, gP.hInstance, byval %NULL)
    ListDeleteAll(gP.hList)
    local zTmp as asciiz * %MAX_PATH
    local WashFind, hFind as DWORD
    local sItem as string
    local fd as WIN32_FIND_DATA

    local sPathName, sArrangement as string
    zSplitN(sFullPathName, sPathName, sArrangement)
    sArrangement = LCASE$(sArrangement)

    PathCombine(gP.szresource, (sPathName), "*.car")

    WashFind = FindFirstFile(gP.szresource, fd)
    hFind = WashFind
    if (LEN(fd.cFileName)) then
        do while hFind > 0
           if asc(fd.cFileName) <> 46 then
              if instr(CHR$(0,1,32,33,128), CHR$(fd.dwFileAttributes)) then
                 zTmp = fd.cFileName: CharLowerA(zTmp)
        
                 if ListAdd(gP.hList, zTmp) > -1 then
                    nCount += 1
                    if (zTmp = sArrangement) then nBackground = nCount
                 end if
        
              end if
           end if
        
           hFind = FindNextFile(WashFind, fd)
        loop
    end if
    FindClose(WashFind)
    if (nCount > 0) then
        if nCount < 5 then
            zTmp = " "
            if nCount < 4 then
               for K = 1 to 2: ListInsert(gP.hList, 1, zTmp): nCount +=1: next
            else
               ListInsert(gP.hList, 1, zTmp): nCount += 1
               ListDelete(gP.hList, ListCount(gP.hList))
               ListInsert(gP.hList, 1, zTmp)
            end if
            if nCount < 5 then
               nCount += 1
               for K = nCount to 5: ListAdd(gP.hList, zTmp): next
            end if
        end if
        if (nBackground > 0) then
            if (ListGetText(gP.hList, 3) <> sArrangement) then
                do
                    sItem = ListGetText(gP.hList, 1)
                    ListDelete(gP.hList, 1)
                    ListAdd(gP.hList, (sItem))
                loop while (ListGetText(gP.hList, 3) <> sArrangement)
            end if
        end if
    end if
end sub

sub MoveThumbVert(byval nID as long, byval nMouseY as long, byval THUMB_VERT as long, byval SLIDER_VERT as long)
    local x, y, nY, w, h, nH, nHalf, nPosY, nPercent, nRedraw as long
    if (nID < THUMB_VERT) then nID += THUMB_VERT - SLIDER_VERT
    ZD_GetObjectXY(nID - (THUMB_VERT - SLIDER_VERT), x, nY)
    ZD_GetObjectBound(nID - (THUMB_VERT - SLIDER_VERT), w, nH)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y): nRedraw = y
    nHalf = h \ 2
    y = min&(max&(nMouseY - nHalf, nY + 3 - nHalf), nY + nH - 2 - nHalf)
    if (y <> nRedraw) then
        nPosY = (nY + nH - 2) - (y + nHalf)
        nPercent = (nPosY / (nH - 5)) * 100

        ZD_SetObjectXY(nID, x, y, %TRUE)
        PostMessage(GetParent(gP.imagectrl), %WM_VSCROLL, MAKLNG(%SB_THUMBPOSITION, nPercent), nID)
    end if
end sub

sub MoveThumbHorz(byval nID as long, byval nMouseX as long, byval THUMB_HORZ as long, byval SLIDER_HORZ as long, byval PROGRESS_HORZ as long)
    local x, y, nX, nY, w, h, nW, nHalf, nPosX, nPercent, nRedraw as long
    if (nID < THUMB_HORZ) then nID += THUMB_HORZ - SLIDER_HORZ
    ZD_GetObjectXY(nID - (THUMB_HORZ - SLIDER_HORZ), nX, y)
    ZD_GetObjectBound(nID - (THUMB_HORZ - SLIDER_HORZ), nW, h)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y): nRedraw = x
    nHalf = w \ 2
    x = min&(max&(nMouseX - nHalf, nX + 3 - nHalf), nX + nW - 2 - nHalf)
 
    if (x <> nRedraw) then
        nPosX = (nX + nW - 2) - (x + nHalf)
        nPercent = 100 - (nPosX / (nW - 5)) * 100

        ZD_GetObjectBound(PROGRESS_HORZ, w, h)
        ZD_GetObjectXY(PROGRESS_HORZ, nX, nY)
        ZD_DrawRectangleToCtrl(gP.imagectrl, nX + 1, nY + 1, x + nHalf - (nX + 1), h - 1, %HIGHLIGHT, 0, PROGRESS_HORZ, %ZS_VISIBLE, %ZD_DRAW_FILLED, 0)

        ZD_SetObjectXY(nID, x, y, %TRUE)
        PostMessage(GetParent(gP.imagectrl), %WM_HSCROLL, MAKLNG(%SB_THUMBPOSITION, nPercent), nID)
    end if
end sub

sub SetThumbVert(byval nID as long, byval THUMB_VERT as long, byval SLIDER_VERT as long, byval nPercent as long)
    local x, y, nY, w, h, nH, nHalf, nVisible as long
    if (nID < THUMB_VERT) then nID += THUMB_VERT - SLIDER_VERT
    ZD_GetObjectXY(nID - (THUMB_VERT - SLIDER_VERT), x, nY)
    ZD_GetObjectBound(nID - (THUMB_VERT - SLIDER_VERT), w, nH)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y)
    nHalf = h \ 2
    nY = (nY + nH - 2) - ((nPercent * (nH - 5)) / 100) - nHalf
    if (nY <> y) then
        nVisible = IsWindowVisible(gP.hMain)
        ZD_SetObjectXY(nID, x, nY, nVisible)
        if (nVisible) then PostMessage(GetParent(gP.imagectrl), %WM_VSCROLL, MAKLNG(%SB_THUMBPOSITION, nPercent), nID)
    end if
end sub

sub SetThumbHorz(byval nID as long, byval THUMB_HORZ as long, byval SLIDER_HORZ as long, byval PROGRESS_HORZ as long, byval nPercent as long)
    local x, y, nX, nY, w, h, nW, nHalf as long
    if (nID < THUMB_HORZ) then nID += THUMB_HORZ - SLIDER_HORZ
    ZD_GetObjectXY(nID - (THUMB_HORZ - SLIDER_HORZ), nX, y)
    ZD_GetObjectBound(nID - (THUMB_HORZ - SLIDER_HORZ), nW, h)
    ZD_GetObjectBound(nID, w, h)
    ZD_GetObjectXY(nID, x, y)
    nHalf = w \ 2
    nPercent = 100 - nPercent
    nX = (nX + nW - 2) - ((nPercent * (nW - 5)) / 100) - nHalf
    if (nX <> x) then
        x = nX
        ZD_GetObjectBound(PROGRESS_HORZ, w, h)
        ZD_GetObjectXY(PROGRESS_HORZ, nX, nY)
        ZD_DrawRectangleToCtrl(gP.imagectrl, nX + 1, nY + 1, x + nHalf - (nX + 1), h - 1, %HIGHLIGHT, 0, PROGRESS_HORZ, %ZS_VISIBLE, %ZD_DRAW_FILLED, 0)

        ZD_SetObjectXY(nID, x, y, IsWindowVisible(gP.hMain))
        'PostMessage(GetParent(gP.imagectrl), %WM_HSCROLL, MAKLNG(%SB_THUMBPOSITION, nPercent), nID)
    end if
end sub

sub SetPlayPercentage(byval nPercent as long)
    SetThumbHorz(%ID_THUMB_HORZ, %ID_THUMB_HORZ, %ID_SLIDER_HORZ, %ID_PROGRESS_HORZ, nPercent)
end sub

function IsPUSHBUTTON (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_PUSH_BUTTON) and (nID < %ID_PUSH_BUTTON + 100)) then nRet = -1
    function = nRet
end function

function IsGAUGE (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_GAUGE_BACK - 1) and (nID < %ID_GAUGE_LIGHT + (%ID_GAUGE_FRONT - %ID_GAUGE_BACK))) then nRet = -1
    function = nRet
end function

function IsSLIDER_VERT (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_SLIDER_VERT - 1) and (nID < %ID_THUMB_VERT + (%ID_THUMB_VERT - %ID_SLIDER_VERT))) then nRet = -1
    function = nRet
end function

function IsSLIDER_HORZ (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_SLIDER_HORZ - 1) and (nID < %ID_THUMB_HORZ + (%ID_THUMB_HORZ - %ID_SLIDER_HORZ))) then nRet = -1
    function = nRet
end function

function IsTICKER (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_TICK_BACK - 1) and (nID < %ID_TICK_FRONT + (%ID_TICK_FRONT - %ID_TICK_BACK))) then nRet = -1
    function = nRet
end function

function IsSWITCH (byval nID as long) as long
    local nRet as long
    nRet = 0
    if ((nID > %ID_BTN_SWITCH - 1) and (nID < %ID_GAUGE_BACK)) then nRet = -1
    function = nRet
end function

sub SetTicker(byval nID as long, byval nMouseX as long, byval nMouseY as long, byval seedangle as long)
    local x, y, w, h, nAngle, nTick as long
    static nmh as NMHDR

    if (nID < %ID_TICK_FRONT) then nID += %ID_TICK_FRONT - %ID_TICK_BACK
    ZD_GetObjectXY(nID, x, y)
    ZD_GetObjectBound(nID, w, h)

    if (seedangle < 0) then
        if (nMouseY > y + (h \ 2)) then
            if (nMouseX > x + (h \ 2)) then
                nMouseX = x + (x + h - nMouseX)
                nMouseY = y + (y + h - nMouseY)
            else
                nMouseX = x + h -(nMouseX - x)
                nMouseY = y + h -(nMouseY - y)
            end if
        end if
    end if

    nAngle = ZD_ComputeObjectAngleFromPoint(nID, nMouseX, nMouseY) - 270
    ZD_SetObjectAngle(nID, 0, %FALSE)
    if (nAngle < 0) then nAngle += 360
    if (nAngle > 359) then nAngle -= 360
    if (nMouseX < x + (h \ 2)) then
        nTick = (nAngle + 15) \ 30
        if (nAngle + 15 > 359) then nTick = 0
        nAngle = nTick * 30
        if ((nAngle < 270) and (nTick <> 0)) then nAngle = 270
        if (nTick) then nTick -= 12
    else
        nTick = (nAngle + 15) \ 30
        nAngle = nTick * 30
        if (nAngle > 90) then nAngle = 90
    end if
    ZD_SetObjectAngle(nID, nAngle, %TRUE)

    '// Notify the parent of the tick value
    nmh.code = min&(max&(nTick, -3), 3)
    nmh.idFrom = nID
    nmh.hwndFrom = gP.imagectrl
    PostMessage(GetParent(gP.imagectrl), %WM_NOTIFY, nID, byval VARPTR(nmh))
end sub

function GDImageCallBack(byval hWnd as long, byval Msg as long, byval wParam as long, byval lParam as long) EXPORT as long
    local x, y, w, h, nID, nFrame, nRet, useAngle, nAngle, nMouseX, nMouseY, nTick, nPercent as long
    static nmh as NMHDR
    local hBitmap as DWORD
    nRet = %FALSE '// do not stop the event processing in GDImage
    nID = ZI_MouseOverObjectID()

    select case long Msg

    case %WM_LBUTTONDOWN, %WM_LBUTTONDBLCLK
         nMouseX = LO(INTEGER, lParam): nMouseY = HI(INTEGER, lParam)
         gP.focusID = 0
         if (IsSLIDER_VERT(nID)) then
             MoveThumbVert(nID, nMouseY, %ID_THUMB_VERT, %ID_SLIDER_VERT)
         elseif (IsSLIDER_HORZ(nID)) then
             MoveThumbHorz(nID, nMouseX, %ID_THUMB_HORZ, %ID_SLIDER_HORZ, %ID_PROGRESS_HORZ)
         elseif (IsGAUGE(nID)) then
             gP.seedangle = ZD_ComputeObjectAngleFromPoint(nID, nMouseX, nMouseY)
             gP.focusID = nID
         elseif (IsTICKER(nID)) then
             gP.seedangle = 0
             gP.focusID = nID
         elseif (IsPUSHBUTTON(nID)) then
             if (ZD_GetObjectFrameToUse(nID) <> 2) then
                 ZD_SetObjectFrameToUse(nID, 2, %TRUE)
                 gP.pushID = nID
             end if
         end if

    case %WM_RBUTTONDOWN, %WM_RBUTTONDBLCLK
         if (IsSLIDER_VERT(nID)) then
             SetThumbVert(nID, %ID_THUMB_VERT, %ID_SLIDER_VERT, 50)
         end if

    case %WM_LBUTTONUP
         if (nID > %ID_ARROW) then
             PostMessage(GetParent(gP.imagectrl), %WM_COMMAND, MAKLNG(nID, %BN_CLICKED), gP.imagectrl)
             EXIT SELECT
         end if

         nMouseX = LO(INTEGER, lParam): nMouseY = HI(INTEGER, lParam)
         if (nID < %ID_PUSH_BUTTON) then
             if nID = %ID_MIX_ENABLE then
                 nFrame = ZD_GetObjectFrameToUse(nID) + 1
                 if (nFrame > ZD_GetObjectFrameCount(nID)) then nFrame = 1
                 ZD_SetObjectFrameToUse(nID, nFrame, %TRUE)
                 PostMessage(GetParent(gP.imagectrl), %WM_COMMAND, MAKLNG(nID, nFrame), gP.imagectrl)
             elseif nID = %ID_DYN_ENABLE then
                 nFrame = ZD_GetObjectFrameToUse(nID) + 1
                 if (nFrame > ZD_GetObjectFrameCount(nID)) then nFrame = 1
                 ZD_SetObjectFrameToUse(nID, nFrame, %TRUE)
                 PostMessage(GetParent(gP.imagectrl), %WM_COMMAND, MAKLNG(nID, nFrame), gP.imagectrl)
             elseif nID = %ID_LIST_ARRANGE then

                 ZD_GetObjectXY(%ID_LIST_ARRANGE, x, y)
                 ZD_GetObjectBound(%ID_LIST_ARRANGE, w, h)
                 if (HI(INTEGER, lParam) - y) > h \ 2 then nID = %DOWN else nID = %UP
                 ZD_SetObjectTextEx(%ID_LIST_TEXT, (sListMsg(nID)), %TRUE)

                 PostMessage(GetParent(gP.imagectrl), %WM_COMMAND, MAKLNG(%ID_LIST_ARRANGE, %LBN_SELCHANGE), gP.imagectrl)
'                 '// We change the background
'                 PathCombine(gP.szresource, EXEresource(), ListGetText(gP.hList, 3))
'                 hBitmap = ZI_FitBitmapFromFile(gP.szresource, %ClientWidth, %ClientHeight)
'                 if (hBitmap) then
'                     ZD_DrawBitmapToCtrl(gP.imagectrl, 0, 0, hBitmap, %OPAQUEIMAGE, %ID_BACKGROUND, %ZS_VISIBLE)
'                     ZI_UpdateWindow(gP.imagectrl, 0)
'                     CopyFile(gP.szresource, EXEresource() + "back" + PATHNAME$(EXTN, ListGetText(gP.hList, 3)), %FALSE)
'                 end if
             end if
         elseif (IsSWITCH(nID)) then
             nFrame = ZD_GetObjectFrameToUse(nID) + 1
             if nFrame > ZD_GetObjectFrameCount(nID) then nFrame = 1
             ZD_SetObjectFrameToUse(nID, nFrame, %TRUE)
             PostMessage(GetParent(gP.imagectrl), %WM_COMMAND, MAKLNG(nID, nFrame), gP.imagectrl)
         elseif (IsTICKER(nID)) then
             if (gP.seedangle > -1) then
                 SetTicker(nID, nMouseX, nMouseY, gP.seedangle)
             end if
             gP.seedangle = 0
         elseif (IsPUSHBUTTON(nID)) then
             if (gP.pushID) then
                 ZD_SetObjectFrameToUse(gP.pushID, 3, %TRUE)
                 gP.overID = gP.pushID
                 gP.pushID = 0
                 PostMessage(GetParent(gP.imagectrl), %WM_COMMAND, MAKLNG(gP.overID, %BN_CLICKED), gP.imagectrl)
             end if
         elseif (gP.focusID) then
             if (gP.focusID > %ID_GAUGE_FRONT - 1) then
                 gP.prevangle = ZD_GetObjectAngle(gP.focusID)
                 gP.focusID = 0
             end if
         end if

    case %WM_MOUSEMOVE
         '// Detect arrow location
         ZD_GetObjectXY(%ID_LARROW, x, y)
         if (nID < %ID_ARROW) then
             if (x > -1) then
                 ZD_GetObjectBound (%ID_LARROW, w, h)
                 ZD_SetObjectXY(%ID_LARROW, -w + 3, y, %FALSE)
                 ZD_SetObjectXY(%ID_RARROW, %ClientWidth - 3, y, %TRUE)
             end if
         else '// we are above one of the ARROWBUTTON
             if (x < 0) then
                 ZD_GetObjectBound (%ID_LARROW, w, h)
                 ZD_SetObjectXY(%ID_LARROW, 0, y, %FALSE)
                 ZD_SetObjectXY(%ID_RARROW, %ClientWidth - w, y, %TRUE)
             end if
             EXIT SELECT
         end if

         nMouseX = LO(INTEGER, lParam): nMouseY = HI(INTEGER, lParam)

         if (ZI_IsLButtonDown()) then
             if (gP.focusID) then
                 if (IsGAUGE(gP.focusID)) then
                     useAngle = ZD_ComputeObjectAngleFromPoint(gP.focusID, nMouseX, nMouseY)
                     if (useAngle <> gP.wasangle) then
                         nAngle = gP.prevangle + useAngle - gP.seedangle
                         if (nAngle < 0) then nAngle += 360
                         if (nAngle > 359) then nAngle -= 360
                         if (ZD_GetObjectFrameCount(gP.focusID) > 2) then '// In case of light frame
                             ZD_SetObjectAngle(gP.focusID + (%ID_GAUGE_FRONT - %ID_GAUGE_BACK), nAngle, %FALSE)
                         end if
                         ZD_SetObjectAngle(gP.focusID, nAngle, %TRUE)

                         '// Notify the parent of the new angle value
                         nmh.code = nAngle
                         nmh.idFrom = gP.focusID
                         nmh.hwndFrom = gP.imagectrl
                         PostMessage(GetParent(gP.imagectrl), %WM_NOTIFY, gP.focusID, byval VARPTR(nmh))
                     end if
                     gP.wasangle = useAngle
                 elseif (IsTICKER(gP.focusID)) then
                     gP.seedangle = -1
                     SetTicker(gP.focusID, nMouseX, nMouseY, gP.seedangle)
                 end if
             elseif nID = %ID_LIST_ARRANGE then
                 ZD_GetObjectXY(%ID_LIST_ARRANGE, x, y)
                 ZD_GetObjectBound(%ID_LIST_ARRANGE, w, h)
                 if (HI(INTEGER, lParam) - y) > h \ 2 then nID = %DOWN else nID = %UP
                 ZD_SetObjectTextEx(%ID_LIST_TEXT, (sListMsg(nID)), %TRUE)
             elseif (IsSLIDER_VERT(nID)) then
                 MoveThumbVert(nID, nMouseY, %ID_THUMB_VERT, %ID_SLIDER_VERT)
             elseif (IsSLIDER_HORZ(nID)) then
                 MoveThumbHorz(nID, nMouseX, %ID_THUMB_HORZ, %ID_SLIDER_HORZ, %ID_PROGRESS_HORZ)
             end if

         end if

         if (IsPUSHBUTTON(nID)) then
             if (gP.pushID <> 0 and gP.pushID <> nID) then ZD_SetObjectFrameToUse(gP.pushID, 1, %TRUE)
             if (gP.overID <> 0 and gP.overID <> nID) then ZD_SetObjectFrameToUse(gP.overID, 1, %TRUE)
             if (ZD_GetObjectFrameToUse(nID) = 1) then ZD_SetObjectFrameToUse(nID, 3, %TRUE): gP.overID = nID
         elseif gP.overID or gP.pushID then
             if (gP.overID) then
                 if (ZD_GetObjectFrameCount(gP.overID) = 3) then ZD_SetObjectFrameToUse(gP.overID, 1, %TRUE)
             end if
             gP.overID = 0: gP.pushID = 0
         end if

    end select

    function = nRet
end function

sub CreateGauge(byval hBitmap as DWORD, byval GAUGE_BACK as long, byval GAUGE_FRONT as long, byval GAUGE_LIGHT as long, byval x as long, byval y as long, byval nCount as long, byval xStep as long)
    local bmW, bmH, nID, nBack, nFront, nLight, nFrameCount as long
    if (hBitmap) then
        ZI_GetBitmapSize(hBitmap, bmW, bmH)
        nFrameCount = (bmW \ bmH)
        for nID = GAUGE_BACK to GAUGE_BACK + nCount - 1
            nBack = nID: nFront = nID + (GAUGE_FRONT - GAUGE_BACK): nLight = nID + (GAUGE_LIGHT - GAUGE_BACK)
            if (nID = GAUGE_BACK) then '// Use clone to save memory
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nBack, %ZS_VISIBLE)
            else
                ZD_CloneObject(GAUGE_BACK, nBack, x, y)
            end if
            ZD_SetObjectLinked(nBack, nBack)
            ZD_SetObjectFrameCount(nBack, nFrameCount)
            ZD_SetObjectFrameToUse(nBack, 1, %FALSE)
            ZD_SetObjectAnchorMode(nBack, %ANCHOR_CENTER)
            ZD_SetObjectLocked(nBack, %TRUE)
            '// The static GAUGEFRONT sprite.
            ZD_CloneObject(nBack, nFront, x, y)
            ZD_SetObjectLinked(nFront, nBack)
            ZD_SetObjectFrameToUse(nFront, 2, %FALSE)
            ZD_SetObjectLocked(nFront, %TRUE) '// We lock the GAUGEFRONT, because we want to rotate it with the mouse
            if (nFrameCount > 2) then
                ZD_CloneObject(nBack, nLight, x, y)
                ZD_SetObjectLinked(nLight, nBack)
                ZD_SetObjectFrameToUse(nLight, 3, %FALSE)
                ZD_SetObjectZorder (nLight, ZD_GetObjectZorder(nBack))
                ZD_SetObjectLocked(nLight, %TRUE)
            end if

            x += xStep + bmH
        next
    end if
end sub

sub CreateTick(byval hBitmap as DWORD, byval GAUGE_BACK as long, byval GAUGE_FRONT as long, byval GAUGE_TEXT as long, byval x as long, byval y as long, byval nCount as long, byval xStep as long)
    local bmW, bmH, nID, nBack, nFront, nText, nFrameCount as long
    if (hBitmap) then
        PathCombine(gP.szresource, EXEresource(), "font.ttf")
        ZI_GetBitmapSize(hBitmap, bmW, bmH)
        nFrameCount = (bmW \ bmH)
        for nID = GAUGE_BACK to GAUGE_BACK + nCount - 1
            nBack = nID: nFront = nID + (GAUGE_FRONT - GAUGE_BACK): nText = nFront + (GAUGE_TEXT - GAUGE_FRONT)
            if (nID = GAUGE_BACK) then '// Use clone to save memory
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nBack, %ZS_VISIBLE)
            else
                ZD_CloneObject(GAUGE_BACK, nBack, x, y)
            end if
            ZD_SetObjectLinked(nBack, nBack)
            ZD_SetObjectFrameCount(nBack, nFrameCount)
            ZD_SetObjectFrameToUse(nBack, 1, %FALSE)
            ZD_SetObjectAnchorMode(nBack, %ANCHOR_CENTER)
            ZD_SetObjectLocked(nBack, %TRUE)
            '// The static GAUGEFRONT sprite.
            ZD_CloneObject(nBack, nFront, x, y)
            ZD_SetObjectLinked(nFront, nBack)
            ZD_SetObjectFrameToUse(nFront, 2, %FALSE)
            ZD_SetObjectLocked(nFront, %TRUE) '// We lock the GAUGEFRONT, because we want to rotate it with the mouse

            '// The tick text
            ZD_DrawTextToCtrlEx(gP.imagectrl, "0", x, y, bmH, bmH, %OPAQUEIMAGE, gP.szresource, 14, nText, _
                                %ZS_VISIBLE, -1000, %StringAlignmentCenter)
            ZD_SetObjectHidden(nText, 2) '// 2 = Transparent, its ID won't be detected and it couldn't be moved.

            '// The chord text
            ZD_DrawTextToCtrlEx(gP.imagectrl, PitchToChord(GetDisplayLongValue(nText)), x, y - 21, bmH, 20, %HIGHLIGHT, gP.szresource, 14, nText + 10, _
                                %ZS_VISIBLE, -1000, %StringAlignmentCenter)
            ZD_SetObjectHidden(nText, 2) '// 2 = Transparent, its ID won't be detected and it couldn't be moved.

            x += xStep + bmH
        next
    end if
end sub

sub CreateSwitch(byval hBitmap as DWORD, byval OFF_ON as long, byval x as long, byval y as long, byval nCount as long, byval xStep as long)
    local bmW, bmH, nID as long
    if (hBitmap) then
        ZI_GetBitmapSize(hBitmap, bmW, bmH)
        nID = OFF_ON
        for nID = OFF_ON to OFF_ON + nCount - 1
            if (nID = OFF_ON) then
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
            else
                ZD_CloneObject(OFF_ON, nID, x, y)
            end if
            ZD_SetObjectFrameCount(nID, 3)
            ZD_SetObjectFrameToUse(nID, 1, %FALSE)
            ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
            ZD_SetObjectLocked(nID, %TRUE)
            x += xStep + bmH
        next
    end if
end sub

sub CreateSliderVert(byval hBitmap as DWORD, byval hThumb as DWORD, byval nX as long, byval nY as long, byval xStep as long, byval nCount as long)
    local x, y, bmW, bmH, nID as long
    nCount -= 1

    ZI_GetBitmapSize(hBitmap, bmW, bmH)
    x = nX
    y = nY
    for nID = %ID_SLIDER_VERT to %ID_SLIDER_VERT + nCount
        if (nID = %ID_SLIDER_VERT) then
            ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        else
            ZD_CloneObject(%ID_SLIDER_VERT, nID, x, y)
        end if
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
        x += xStep
    next                           

    y = nY + (bmH \ 2)
    ZI_GetBitmapSize(hThumb, bmW, bmH)
    x = nX
    y -= bmH \ 2 - 1
    for nID = %ID_THUMB_VERT to %ID_THUMB_VERT + nCount
        if (nID = %ID_THUMB_VERT) then
            ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hThumb, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        else
            ZD_CloneObject(%ID_THUMB_VERT, nID, x, y)
        end if
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
        x += xStep
    next

end sub

sub CreateSliderHorz(byval hBitmap as DWORD, byval hThumb as DWORD, byval nID_BACK as long, byval nID_THUMB as long, byval nID_PROGRESS as long, byval nX as long, byval nY as long)
    local x, y, w, h, bmW, bmH, nID as long

    ZI_GetBitmapSize(hBitmap, bmW, bmH)
    x = nX
    y = nY
    h = bmH
    nID = nID_BACK
    ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)
    x = nX + (bmW \ 2)

    ZI_GetBitmapSize(hThumb, bmW, bmH)
    x -= bmW \ 2 - 1
    y = nY
    w = x - nX
    nID = nID_PROGRESS
    ZD_DrawRectangleToCtrl(gP.imagectrl, nX, nY + 16, w + (bmW \ 2), 5, %HIGHLIGHT, 0, nID, %ZS_VISIBLE, %ZD_DRAW_FILLED, 0)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    'ZD_SetObjectLocked(nID, %TRUE)
    ZD_SetObjectHidden(nID, 2) '// 2 = Transparent, its ID won't be detected and it couldn't be moved.

    nID = nID_THUMB
    ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hThumb, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)

end sub

function DisplayLongValue(byval nValue as long) as string
    local sRet as string
    sRet = STR$(ABS(nValue))
    ''REPLACE "1" WITH " I" IN sRet
    sRet = LTRIM$(sRet)
    if (nValue < 0) then sRet = "-" + sRet
    function = sRet
end function

function GetDisplayLongValue(byval nID as long) as long
    local sRet as string
    sRet = ZD_GetObjectImageLabel(nID)
    ''REPLACE "I" WITH "1" IN sRet
    REPLACE " " WITH "" IN sRet
    function = VAL(sRet)
end function

function DisplayFloatValue(byval sValue as single) as string
    local sRet as string
    local so as long
    sRet = STR$(ABS(sValue))
    so = INSTR(1, sRet, ".")
    if (so) then
        sRet = sRet + "0"
        sRet = LEFT$(sRet, so + 2)
    else
        sRet = sRet + ".00"
    end if
    ''REPLACE "1" WITH " I" IN sRet
    sRet = LTRIM$(sRet)
    if (ASC(sRet) = 46) then sRet = "0" + sRet
    if (sValue < 0) then sRet = "-" + sRet
    function = sRet
end function

function GetDisplayFloatValue(byval nID as long) as single
    local sRet as string
    sRet = ZD_GetObjectImageLabel(nID)
    ''REPLACE "I" WITH "1" IN sRet
    REPLACE " " WITH "" IN sRet
    function = VAL(sRet)
end function

sub CreateStaticText(szUseFont as asciiz, byval x as long, byval y as long, byval w as long, byval h as long, _
                     byval nFontSize as long, byval nID as long, byval nColor as long, szValue as asciiz)
    ZD_DrawTextToCtrlEx(gP.imagectrl, szValue, x, y+1, w, h, nColor, szUseFont, nFontSize, nID, _
                        %ZS_VISIBLE, 0, %StringAlignmentFar)'%StringAlignmentCenter)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)
end sub

function SetBackground() as DWORD
    local x, y, bmW, bmH, nID as long
    local hBitmap, nRet as DWORD
    DIM Compo(1) as ZOBJECT
    x = 0: y = 0: nRet = 0
    PathCombine(gP.szresource, EXEresource(), ListGetText(gP.hlistback, ListGetCursel(gP.hlistback)))
    hBitmap = ZI_FitBitmapFromFile(gP.szresource, %ClientWidth, %ClientHeight)
    if (hBitmap) then
        ZI_CreateBitmapObject(Compo(0), x, y, hBitmap, %OPAQUEIMAGE, %ZS_VISIBLE)
        PathCombine(gP.szresource, EXEresource(), "layer_bottom.png")
        nRet = hBitmap
        hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
        if (hBitmap) then
            ZI_CreateBitmapObject(Compo(1), x, y, hBitmap, %OPAQUEIMAGE, %ZS_VISIBLE)
            nRet = hBitmap
            hBitmap = ZI_CreateImageComposited("", %ClientWidth, %ClientHeight, VARPTR(Compo(0)), 2)
            if (hBitmap) then
                nID = %ID_BACKGROUND
                ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
                ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
                ZD_SetObjectHidden(nID, 2) '// 2 = Transparent, its ID won't be detected and it couldn't be moved.
                nRet = hBitmap
            else
                DeleteObject(nRet): nRet = 0
            end if
        else
            DeleteObject(nRet): nRet = 0
        end if
    end if
    function = nRet
end function

sub CreateControls()
    local k, x, y, w, h, nLeftX, nRightX, bmW, bmH, nID, nBack, nFront, nLight, xWidth, xStep, nEnum as long
    local nColor, nFontSize, nValue as long
    local sValue as single

    xWidth = 64: xStep = 4
    local nFrameCount as byte
    local hBitmap, hThumb, wasBitmap as DWORD

    '// Create composite image background
    SetBackground()

'-------------------------------------------------------------
    '// Create multiple gauges
    PathCombine(gP.szresource, EXEresource(), "gauge08.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    x = 26: y = 52: nEnum = 1
    CreateGauge(hBitmap, %ID_TEMPO_BACK, %ID_TEMPO_FRONT, %ID_TEMPO_LIGHT, x, y, nEnum, xStep)
    x = 670: y = 52: nEnum = 1
    CreateGauge(hBitmap, %ID_GAIN_BACK, %ID_GAIN_FRONT, %ID_GAIN_LIGHT, x, y, nEnum, xStep)
    x = 25: y = 399: nEnum = 2
    CreateGauge(hBitmap, %ID_VOL_BACK, %ID_VOL_FRONT, %ID_VOL_LIGHT, x, y, nEnum, xStep)
    x = 635: y = 411: nEnum = 2
    CreateGauge(hBitmap, %ID_VOL_BACK_UL, %ID_VOL_FRONT_UL, %ID_VOL_LIGHT_UL, x, y, nEnum, xStep)

    '//Create LCD display control for multiple gauges
    '// Here we are using a private font (no need to register it first)
    PathCombine(gP.szresource, EXEresource(), "lcd.ttf")
    if (zExist(gP.szresource)) then
        nValue = 0
        x = 30: y = 32: w = 50: h = 20: nFontSize = 15: nColor = %HIGHLIGHT
        CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_TEMPO_LED, nColor, DisplayLongValue(nValue))
        x = 676: y = 32
        sValue = 1
        CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_GAIN_LED, nColor, DisplayFloatValue(sValue))
        x = 30: y = 379
        nValue = 50
        CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_VOL_LED, nColor, DisplayLongValue(nValue))
        x = 641: y = 391
        CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_VOL_LED_UL, nColor, DisplayLongValue(nValue))
        x = 98: y = 379
        nValue *= 100
        CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_FADE_LED, nColor, DisplayLongValue(nValue))
        x = 709: y = 391
        CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_FADE_LED_UL, nColor, DisplayLongValue(nValue))

        '//Create LCD display control for multiple sliders
        x = 30: y = 197: w = 50: xStep = 18
        nValue = 50
        for K = 0 to 7
            CreateStaticText(gP.szresource, x, y, w, h, nFontSize, %ID_SLIDER_LED + k, nColor, DisplayLongValue(nValue))
            x += w + xStep
        next
    end if
'--------------------------------------------------------------

    '// Create 3-state button switches
    PathCombine(gP.szresource, EXEresource(), "BTN_radio3.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    x = 25: y = 488: nEnum = 8: xStep = 4
    CreateSwitch(hBitmap, %ID_BTN_SWITCH, x, y, nEnum, xStep)

    '// Draw list text using a private font
    nID = %ID_LIST_FRAME
    w = 300: h = 102
    x = 262: y = 33
    PathCombine(gP.szresource, EXEresource(), "font.ttf")
    nID = %ID_LIST_TEXT
    ZD_DrawTextToCtrlEx(gP.imagectrl, (sListMsg(0)), x, y, -w, -h, ZD_ARGB(255, 255,255,255), _
                        gP.szresource, 16, nID, %ZS_VISIBLE, 0, %StringAlignmentNear)
    ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
    ZD_SetObjectLocked(nID, %TRUE)

    PathCombine(gP.szresource, EXEresource(), "glass.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_LIST_ARRANGE
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Create Pitch/Tempo tick control
    PathCombine(gP.szresource, EXEresource(), "tick.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    x = 93: y = 52: nEnum = 2: xStep = 4
    CreateTick(hBitmap, %ID_TICK_BACK, %ID_TICK_FRONT, %ID_TICK_TEXT, x, y, nEnum, xStep)

    '// Create OnOff switches
    PathCombine(gP.szresource, EXEresource(), "OnOff.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_MIX_ENABLE
        x = 433: y = 152
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 2)
        ZD_SetObjectFrameToUse(nID, 2, %FALSE) '// OFF
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)

        nID = %ID_DYN_ENABLE
        x = 433: y = 356
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 2)
        ZD_SetObjectFrameToUse(nID, 2, %FALSE) '// OFF
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Button RESET and APPLY
    PathCombine(gP.szresource, EXEresource(), "btn_push.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then

        nID = %ID_BTN_RESET
        x = 602: y = 207
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 3)
        ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)

        nID = %ID_BTN_APPLY
        x = 602: y = 285
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 3)
        ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)

        nID = %ID_BTN_SELECT
        x = 602: y = 512
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 3)
        ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if
   
    '// Button PAUSE
    PathCombine(gP.szresource, EXEresource(), "btn_pause.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_BTN_PAUSE
        x = 602: y = 246
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_HIDDEN)
        ZD_SetObjectFrameCount(nID, 3)
        ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if
    '// Button PLAY
    PathCombine(gP.szresource, EXEresource(), "btn_play.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_BTN_PLAY
        x = 602: y = 246
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectFrameCount(nID, 3)
        ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        ZD_SetObjectLocked(nID, %TRUE)
    end if

    '// Create vertical sliders
    x = 44: y = 228: nEnum = 8: xStep = 68
    PathCombine(gP.szresource, EXEresource(), "slideV.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        PathCombine(gP.szresource, EXEresource(), "thumbV.png")
        hThumb = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
        if (hThumb) then
            CreateSliderVert(hBitmap, hThumb, x, y, xStep, nEnum)
        end if
    end if

    '// Create the horizontal slider
    x = 650: y = 246
    PathCombine(gP.szresource, EXEresource(), "slideH.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        PathCombine(gP.szresource, EXEresource(), "thumbH.png")
        hThumb = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
        if (hThumb) then
            CreateSliderHorz(hBitmap, hThumb, %ID_SLIDER_HORZ, %ID_THUMB_HORZ, %ID_PROGRESS_HORZ, x, y)
        end if
    end if

    'PathCombine(gP.szresource, EXEresource(), "volume.png")
    'hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    'x = 602: y = 367
    'if (hBitmap) then
    '    nID = %ID_MAIN_VOLUME
    '    ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
    '    ZD_SetObjectLocked(nID, %TRUE)
    'end if

    '// Create the static layer top group
    PathCombine(gP.szresource, EXEresource(), "layer_top.png")
    x = 0:  y = 0
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, bmW, bmH)
    if (hBitmap) then
        nID = %ID_LAYER_TOP
        ZD_DrawBitmapToCtrl(gP.imagectrl, x, y, hBitmap, %OPAQUEIMAGE, nID, %ZS_VISIBLE)
        ZD_SetObjectAnchorMode(nID, %ANCHOR_CENTER)
        'ZD_SetObjectLocked(nID, %TRUE)
        ZD_SetObjectHidden(nID, 2) '// 2 = Transparent, its ID won't be detected and it couldn't be moved.
    end if

    PathCombine(gP.szresource, EXEresource(), "larrow.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, w, h)
    if (hBitmap) then 
        ZD_DrawBitmapToCtrl(gP.imagectrl, -w + 3, 259, hBitmap, %OPAQUEIMAGE, %ID_LARROW, %ZS_VISIBLE)
        ZD_SetObjectLocked(%ID_LARROW, %TRUE)
        'ZD_SetObjectImageLabel(ID_LARROW, "prev")
    end if

    PathCombine(gP.szresource, EXEresource(), "rarrow.png")
    hBitmap = ZI_CreateBitmapFromFile(gP.szresource, w, h)
    if (hBitmap) then 
        ZD_DrawBitmapToCtrl(gP.imagectrl, %ClientWidth - 3, 259, hBitmap, %OPAQUEIMAGE, %ID_RARROW, %ZS_VISIBLE)
        ZD_SetObjectLocked(%ID_RARROW, %TRUE)
        'ZD_SetObjectImageLabel(ID_RARROW, "next")
    end if

    '// We use a callback to monitor the GDImage control messages
    local lpCallBack as DWORD: lpCallBack = CODEPTR(GDImageCallBack)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_LBUTTONDOWN, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_LBUTTONDBLCLK, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_LBUTTONUP, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_MOUSEMOVE, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_RBUTTONDOWN, %TRUE)
    ZI_EventMessageEx(gP.imagectrl, lpCallBack, %WM_RBUTTONDBLCLK, %TRUE)

end sub

'sub RenderAnimation()
'
'end sub

'// Main window minimum horizontal track size
function MinTrackSizeW (byval SizeX as long) as long
    static WasSizeX as long
    if (SizeX) then WasSizeX = SizeX
    function = WasSizeX
end function

'// Main window minimum vertical track size
function MinTrackSizeH (byval SizeY as long) as long
    static WasSizeY as long
    if (SizeY) then WasSizeY = SizeY
    function = WasSizeY
end function

sub PlaySoundClick()
    if (%PLAYSOUND) then
        PathCombine(gP.szresource, EXEresource(), "tick.wav")
        PlaySound(gP.szresource, byval %NULL, %SND_FILENAME or %SND_ASYNC)
    end if
end sub

sub PlaySoundBlup()
    if (%PLAYSOUND) then
        PathCombine(gP.szresource, EXEresource(), "blup.wav")
        PlaySound(gP.szresource, byval %NULL, %SND_FILENAME or %SND_ASYNC)
    end if
end sub

sub PlaySoundPush()
    if (%PLAYSOUND) then
        PathCombine(gP.szresource, EXEresource(), "push.wav")
        PlaySound(gP.szresource, byval %NULL, %SND_FILENAME or %SND_ASYNC)
    end if
end sub

sub PlaySoundTrackbar()
    if (%PLAYSOUND) then
        PathCombine(gP.szresource, EXEresource(), "trackbar.wav")
        PlaySound(gP.szresource, byval %NULL, %SND_FILENAME or %SND_ASYNC)
    end if
end sub

sub PlaySoundBeep()
    if (%PLAYSOUND) then
        PathCombine(gP.szresource, EXEresource(), "beep.wav")
        PlaySound(gP.szresource, byval %NULL, %SND_FILENAME or %SND_ASYNC)
    end if
end sub

function TickToAngle(byval nTick as long) as long
    local nAngle as long
    nAngle = nTick * 30
    if (nTick < 0) then nAngle += 360
    function = nAngle
end function

function PercentageToAngle(byval nPercent as long) as long
    local nAngle as long
    nAngle = nPercent * 3.6
    if nPercent < 51 then nAngle += 180 else nAngle -= 180
    function = nAngle
end function

function OpenFileSelector(byval hWnd as DWORD, _            ' parent window
                          byval sCaption as string, _       ' caption
                          sFileSpec as string, _            ' filename
                          byval sInitialDir as string, _    ' start directory
                          byval sFilter as string, _        ' filename filter
                          byval sDefExtension as string, _  ' default extension
                          dFlags as DWORD _                 ' flags
                          ) as long

    local ix          as long
    local ofn         as OPENFILENAME
    local szFileTitle as asciiz * %MAX_PATH

    ' Filter is a sequence of ASCIIZ strings with a final (extra) $NUL terminator
    REPLACE "|" WITH $NUL IN sFilter
    sFilter = sFilter + $NUL

    if LEN(sInitialDir) = 0 then
        sInitialDir = CURDIR$
    end if

    ix = INSTR(sFileSpec, $NUL)
    if ix then
        sFileSpec = LEFT$(sFileSpec, ix) + SPACE$(8192 - ix)
    else
        sFileSpec = sFileSpec + $NUL + SPACE$(8192 - (LEN(sFileSpec) + 1))
    end if

    ofn.lStructSize      = SIZEOF(ofn)
    ofn.hWndOwner        = hWnd
    ofn.lpstrFilter      = STRPTR(sFilter)
    ofn.nFilterIndex     = 1
    ofn.lpstrFile        = STRPTR(sFileSpec)
    ofn.nMaxFile         = LEN(sFileSpec)
    ofn.lpstrFileTitle   = VARPTR(szFileTitle)
    ofn.nMaxFileTitle    = SIZEOF(szFileTitle)
    ofn.lpstrInitialDir  = STRPTR(sInitialDir)
    if LEN(sCaption) then
        ofn.lpstrTitle   = STRPTR(sCaption)
    end if
    ofn.Flags            = dFlags
    if LEN(sDefExtension) then
        ofn.lpstrDefExt  = STRPTR(sDefExtension)
    end if

    function = GetOpenFilename(ofn)

    ix = INSTR(-1, sFileSpec, $NUL)
    if (ix) then
        sFileSpec = LEFT$(sFileSpec, ix - 1)
    else
        sFileSpec = ""
    end if

    dFlags = ofn.Flags

end function

function FileOpen (byval hWnd as DWORD) as string
    local sPath, sOptions, sfile as string
    local dwStyle as DWORD

    sPath = CURDIR$
    sOptions = "Audio files (*.mp3;*.ogg)|*.MP3;*.OGG|"
    sfile    = "*.mp3;*.ogg"
    dwStyle = %OFN_EXPLORER or %OFN_FILEMUSTEXIST
    if OpenFileSelector(hWnd, "Select user loop", sfile, sPath, sOptions, "mp3", dwStyle) then
       function = sfile
    end if
end function

function TransposeChord(byval sChord as string, byval nPitch as long) as string
    local sResult as string
    DIM sTranspose(1 TO 12) as string
    sResult = sChord
    ARRAY ASSIGN sTranspose() = "C", "C#", "D", "D#", "E", "F", "F#", "G", "G#", "A", "A#", "B"
    local K, MaxK, nFound as long
    MaxK = 12
    for K = 1 to MaxK
        if sTranspose(K) = sChord then
           nFound = (K + nPitch) MOD MaxK
           if nFound < 1 then nFound += MaxK
           sResult = sTranspose(nFound)
           EXIT FOR
        end if
    next
    function = sResult
end function

function PitchToChord(byval nPitch as long) as string
    local sChord as string
    if RIGHT$(gP.szsongpath, 2) = ")\" then
       sChord = EXTRACT$(-1, LEFT$(gP.szsongpath, LEN(gP.szsongpath) - 2), "(")
       sChord = TransposeChord(sChord, nPitch)
    end if
    function = sChord
end function

sub LoadTempoPitch()
    local sBuf as string
    local fHandle, dwBytesReaden as DWORD, bErrorFlag, nPercent, nValue as long
    'PathCombine(gP.szresource, gP.szsongpath, "Channels.fx")
    PathCombine(gP.szresource, EXEpath(), "Channels.fx")
    if (zExist(gP.szresource)) then
        fHandle = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then 
            local nSize as DWORD
            nSize = GetFileSize(fHandle, nSize): if (nSize = %INVALID_HANDLE_VALUE) then nSize = 0
            if (nSize) then
                sBuf = SPACE$(nSize)
                bErrorFlag = ReadFile(fHandle, byval STRPTR(sBuf), nSize, dwBytesReaden, byval %NULL)
            end if
            CloseHandle(fHandle)
        end if
        if (LEN(sBuf)) then
            nValue = VAL(PARSE$(sBuf, 1))
            ZD_SetObjectTextEx(%ID_TEMPO_LED, DisplayLongValue(nValue), %FALSE)
            nValue *= 2.5: nValue += 50
            ZD_SetObjectAngle(%ID_TEMPO_FRONT, PercentageToAngle(nValue), %FALSE)

            nValue = VAL(PARSE$(sBuf, 2))
            ZD_SetObjectTextEx(%ID_PITCH_TEXT, DisplayLongValue(nValue), %FALSE)
            ZD_SetObjectTextEx(%ID_PITCH_CHORD, PitchToChord(nValue), %FALSE)
            ZD_SetObjectAngle(%ID_PITCH_FRONT, TickToAngle(nValue), %FALSE)

            nValue = VAL(PARSE$(sBuf, 4))
            ZD_SetObjectTextEx(%ID_DYNAMIC_TEXT, DisplayLongValue(nValue), %FALSE)
            ZD_SetObjectTextEx(%ID_DYNAMIC_CHORD, PitchToChord(nValue), %FALSE)
            ZD_SetObjectAngle(%ID_DYNAMIC_FRONT, TickToAngle(nValue), %FALSE)
        end if
    end if
end sub

sub SaveTempoPitch()
    local sBuf as string
    local fHandle, dwBytesWritten as DWORD, bErrorFlag as long
    'PathCombine(gP.szresource, gP.szsongpath, "Channels.fx")
    PathCombine(gP.szresource, EXEpath(), "Channels.fx")
    fHandle = CreateFile(gP.szresource, %GENERIC_WRITE, 0, BYVAL %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, BYVAL %NULL)
    if (fHandle <> %INVALID_HANDLE_VALUE) then
	    sBuf = DisplayLongValue(GetDisplayLongValue(%ID_TEMPO_LED)) + $Comma + _
               DisplayLongValue(GetDisplayLongValue(%ID_PITCH_TEXT)) + $Comma + _
               "44100" + $Comma + _
               DisplayLongValue(GetDisplayLongValue(%ID_DYNAMIC_TEXT)) + $Comma
        bErrorFlag = WriteFile(fHandle, byval STRPTR(sBuf), len(sBuf), dwBytesWritten, byval %NULL)
	    CloseHandle(fHandle)
    end if
end sub

sub LoadDynamicsAndUserLoop()
    local sBuf as string
    local fHandle, dwBytesReaden as DWORD, K, bErrorFlag, nID, nFrame, nPercent, nDuration as long
    local sValue as single
    DIM Channel(1 TO %MAXCHANNEL) as STChannel
    'PathCombine(gP.szresource, gP.szsongpath, "Channels.bin")
    PathCombine(gP.szresource, EXEpath(), "Channels.bin")
    if (zExist(gP.szresource)) then
        fHandle = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then
            local nFileSize, nBufferSize as DWORD
            nBufferSize = sizeof(STChannel) * %MAXCHANNEL
            nFileSize = GetFileSize(fHandle, nFileSize): if (nFileSize = %INVALID_HANDLE_VALUE) then nFileSize = 0
            if (nFileSize \ sizeof(STChannel) = 8) then nBufferSize = nFileSize '// Version 3 and lower.
			if (nFileSize < nBufferSize) then
				nBufferSize = 0
			else
                bErrorFlag = ReadFile(fHandle, byval VARPTR(Channel(1)), nBufferSize, dwBytesReaden, byval %NULL)
			end if
			CloseHandle(fHandle)
        end if
		if (nBufferSize > 0) then
            nPercent = 0: nDuration = 0
            for K = 1 to %MAXCHANNEL
                if (K = %MAXCHANNEL) then
                    ZD_SetObjectTextEx(%ID_VOL_LED_UL, DisplayLongValue(Channel(K).percent), %FALSE)
                    ZD_SetObjectAngle(%ID_VOL_FRONT_UL, PercentageToAngle(Channel(K).percent), %FALSE)
                    ZD_SetObjectTextEx(%ID_FADE_LED_UL, DisplayLongValue(Channel(K).duration), %FALSE)
                    ZD_SetObjectAngle(%ID_FADE_FRONT_UL, PercentageToAngle(Channel(K).duration * 0.01), %FALSE)
                else
                    nID = %ID_BTN_SWITCH + K - 1
                    nFrame = 1
                    if (nPercent = 0) then nPercent = Channel(K).percent
                    if (nDuration = 0) then nDuration = Abs(Channel(K).duration)
                    if ((Channel(K).percent = 0) and (Channel(K).duration = 0)) then
                        ZD_SetObjectFrameToUse(nID, nFrame, %FALSE)
                    else
                        if (Channel(K).duration < 0) then nFrame = 3 else nFrame = 2 '// Mute status = 3
                        ZD_SetObjectFrameToUse(nID, nFrame, %FALSE)
                    end if
                end if
            next
            if (nPercent = 0) then
                if (nDuration) then nPercent = 100
            end if
            ZD_SetObjectTextEx(%ID_VOL_LED, DisplayLongValue(nPercent), %FALSE)
            ZD_SetObjectAngle(%ID_VOL_FRONT, PercentageToAngle(nPercent), %FALSE)
            ZD_SetObjectTextEx(%ID_FADE_LED, DisplayLongValue(nDuration), %FALSE)
            ZD_SetObjectAngle(%ID_FADE_FRONT, PercentageToAngle(nDuration * 0.01), %FALSE)
		end if
    end if
end sub

sub SaveDynamicsAndUserLoop()
    local fHandle, dwBytes as DWORD, K, bErrorFlag, nID, nFrame, nMul as long
    local nFileSize, nBufferSize as DWORD
    DIM Channel(1 TO %MAXCHANNEL) as STChannel
    'PathCombine(gP.szresource, gP.szsongpath, "Channels.bin")
    PathCombine(gP.szresource, EXEpath(), "Channels.bin")
    if (zExist(gP.szresource)) then
        nBufferSize = sizeof(STChannel) * %MAXCHANNEL
        fHandle = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then
            nFileSize = GetFileSize(fHandle, nFileSize): if (nFileSize = %INVALID_HANDLE_VALUE) then nFileSize = 0
            if (nFileSize \ sizeof(STChannel) = 8) then nBufferSize = nFileSize '// Version 3 and lower.
            if (nFileSize < nBufferSize) then
                nBufferSize = 0
            else
                bErrorFlag = ReadFile(fHandle, byval VARPTR(Channel(1)), nBufferSize, dwBytes, byval %NULL)
            end if
            CloseHandle(fHandle)
        end if
    end if
    nBufferSize = sizeof(STChannel) * %MAXCHANNEL
    for K = 1 to %MAXCHANNEL
        if (K = %MAXCHANNEL) then
            Channel(K).percent = GetDisplayLongValue(%ID_VOL_LED_UL)
            Channel(K).duration = GetDisplayLongValue(%ID_FADE_LED_UL)
        else
            nID = %ID_BTN_SWITCH + K - 1
            nFrame = ZD_GetObjectFrameToUse(nID)
            if (nFrame = 1) then
                Channel(K).percent = 0
                Channel(K).duration = 0
            else
                Channel(K).percent = GetDisplayLongValue(%ID_VOL_LED)
                if (nFrame = 3) then nMul = -1 else nMul = 1 '// Mute status
                Channel(K).duration = GetDisplayLongValue(%ID_FADE_LED) * nMul
            end if
        end if
    next
    fHandle = CreateFile(gP.szresource, %GENERIC_WRITE, 0, BYVAL %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, BYVAL %NULL)
    if (fHandle <> %INVALID_HANDLE_VALUE) then
        bErrorFlag = WriteFile(fHandle, byval VARPTR(Channel(1)), nBufferSize, dwBytes, byval %NULL)
	    CloseHandle(fHandle)
    end if
end sub

function zStr(byval n as long) as string
    function = LTRIM$(STR$(n))
end function

function zPad(byval n as long, byval sPad as string) as string
    function = RIGHT$(sPad + zStr(n), LEN(sPad))
end function

function GetFileDate(byval hFile as DWORD) as string
    DIM LocalTime AS SYSTEMTIME
    DIM LastWriteTime AS FILETIME
    '// Get the file time
    GetFileTime(hFile, byval %NULL, byval %NULL, LastWriteTime)
    '// Translate to local file time.
    FileTimeToSystemTime(LastWriteTime, LocalTime)
    '//function = STR$(LocalTime.WYear) & FORMAT$(LocalTime.wMonth, "00") & FORMAT$(LocalTime.wDay, "00") & FORMAT$(LocalTime.wHour, "00") & FORMAT$(LocalTime.wMinute, "00") & FORMAT$(LocalTime.wSecond, "00")
    function = STR$(LocalTime.WYear) + zPad(LocalTime.wMonth, "00") + zPad(LocalTime.wDay, "00") + zPad(LocalTime.wHour, "00") + zPad(LocalTime.wMinute, "00") + zPad(LocalTime.wSecond, "00")
end function
        
sub LoadCustomMixes()
    local sBuf as string
    local fHandle, dwBytesReaden as DWORD, K, bErrorFlag, nPercent, nValue, nID as long
    local sValue as single
    DIM Channel(1 TO %MAXCHANNEL) as STChannel
    'PathCombine(gP.szresource, gP.szsongpath, "Channels.bin")
    PathCombine(gP.szresource, EXEpath(), "Channels.bin")
    if (zExist(gP.szresource)) then
        fHandle = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then
            local nFileSize, nBufferSize as DWORD
            nBufferSize = sizeof(STChannel) * %MAXCHANNEL
            nFileSize = GetFileSize(fHandle, nFileSize): if (nFileSize = %INVALID_HANDLE_VALUE) then nFileSize = 0
            if (nFileSize \ sizeof(STChannel) = 8) then nBufferSize = nFileSize '// Version 3 and lower.
			if (nFileSize < nBufferSize) then
				nBufferSize = 0
			else
                bErrorFlag = ReadFile(fHandle, byval VARPTR(Channel(1)), nBufferSize, dwBytesReaden, byval %NULL)
			end if
			CloseHandle(fHandle)
        end if
		if (nBufferSize > 0) then
			'// 06-03-2011 Warning WE MUST NOT READ/OVERWRITE the gnChannel[K].ID with the one stored in the bin file.
			for K = 1 to %MAXCHANNEL - 1
                nID = %ID_THUMB_VERT + K - 1
                SetThumbVert(nID, %ID_THUMB_VERT, %ID_SLIDER_VERT, Channel(K).Volume)
            next
		end if
    end if
end sub

sub SaveCustomMixes()
    local fHandle, dwBytes as DWORD, K, bErrorFlag, nID as long
    local nFileSize, nBufferSize as DWORD
    DIM Channel(1 TO %MAXCHANNEL) as STChannel
    'PathCombine(gP.szresource, gP.szsongpath, "Channels.bin")
    PathCombine(gP.szresource, EXEpath(), "Channels.bin")
    if (zExist(gP.szresource)) then
        nBufferSize = sizeof(STChannel) * %MAXCHANNEL
        fHandle = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then
            nFileSize = GetFileSize(fHandle, nFileSize): if (nFileSize = %INVALID_HANDLE_VALUE) then nFileSize = 0
            if (nFileSize \ sizeof(STChannel) = 8) then nBufferSize = nFileSize '// Version 3 and lower.
            if (nFileSize < nBufferSize) then
                nBufferSize = 0
            else
                bErrorFlag = ReadFile(fHandle, byval VARPTR(Channel(1)), nBufferSize, dwBytes, byval %NULL)
            end if
            CloseHandle(fHandle)
        end if
    end if
    nBufferSize = sizeof(STChannel) * %MAXCHANNEL
    for K = 1 to %MAXCHANNEL - 1
        nID = %ID_SLIDER_LED + K - 1
        Channel(K).Volume = GetDisplayLongValue(nID)
    next
    fHandle = CreateFile(gP.szresource, %GENERIC_WRITE, 0, BYVAL %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, BYVAL %NULL)
    if (fHandle <> %INVALID_HANDLE_VALUE) then
        bErrorFlag = WriteFile(fHandle, byval VARPTR(Channel(1)), nBufferSize, dwBytes, byval %NULL)
	    CloseHandle(fHandle)
    end if
end sub

sub LoadGain()
    local sBuf as string
    local fHandle, dwBytesReaden as DWORD, bErrorFlag, nPercent as long
    local sValue as single
    'PathCombine(gP.szresource, gP.szsongpath, "Gain.cfg")
    PathCombine(gP.szresource, EXEpath(), "Gain.cfg")
    if (zExist(gP.szresource)) then
        fHandle = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
        if (fHandle <> %INVALID_HANDLE_VALUE) then 
            local nSize as DWORD
            nSize = GetFileSize(fHandle, nSize): if (nSize = %INVALID_HANDLE_VALUE) then nSize = 0
            if (nSize) then
                sBuf = SPACE$(nSize)
                bErrorFlag = ReadFile(fHandle, byval STRPTR(sBuf), nSize, dwBytesReaden, byval %NULL)
            end if
            CloseHandle(fHandle)
        end if
        if (LEN(sBuf)) then
            sValue = VAL(sBuf)
            ZD_SetObjectTextEx(%ID_GAIN_LED, DisplayFloatValue(sValue), %FALSE)
            nPercent = sValue * 50
            ZD_SetObjectAngle(%ID_GAIN_FRONT, PercentageToAngle(nPercent), %FALSE)
        end if
    end if
end sub

sub SaveGain()
    local sBuf as string
    local fHandle, dwBytesWritten as DWORD, bErrorFlag as long
    'PathCombine(gP.szresource, gP.szsongpath, "Gain.cfg")
    PathCombine(gP.szresource, EXEpath(), "Gain.cfg")
    fHandle = CreateFile(gP.szresource, %GENERIC_WRITE, 0, BYVAL %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, BYVAL %NULL)
    if (fHandle <> %INVALID_HANDLE_VALUE) then
	    sBuf = DisplayFloatValue(GetDisplayFloatValue(%ID_GAIN_LED))
        bErrorFlag = WriteFile(fHandle, byval STRPTR(sBuf), len(sBuf), dwBytesWritten, byval %NULL)
	    CloseHandle(fHandle)
    end if
end sub

sub UpdateSkinBackground()
    PathCombine(gP.szresource, EXEresource(), ListGetText(gP.hlistback, ListGetCursel(gP.hlistback)))
    CopyFile(gP.szresource, skSkinFolder() + "CTLBACK.png", %FALSE)
    PathCombine(gP.szresource, EXEpath(), "Ampli.sks")
    skInitEngine(gP.szresource, $FLYWLFT)
    SendMessageA(gP.hMain, %WM_SIZE, 0, 0)
end sub

sub ResetToDefault()
    local K, nID, nValue, nPercent, nDuration as long, sValue as single

    '// TempoPitch
    nValue = 0
    ZD_SetObjectTextEx(%ID_TEMPO_LED, DisplayLongValue(nValue), %FALSE)
    nValue *= 2.5: nValue += 50
    ZD_SetObjectAngle(%ID_TEMPO_FRONT, PercentageToAngle(nValue), %FALSE)

    nValue = 0
    ZD_SetObjectTextEx(%ID_PITCH_TEXT, DisplayLongValue(nValue), %FALSE)
    ZD_SetObjectTextEx(%ID_PITCH_CHORD, PitchToChord(nValue), %FALSE)
    ZD_SetObjectAngle(%ID_PITCH_FRONT, TickToAngle(nValue), %FALSE)

    nValue = 0
    ZD_SetObjectTextEx(%ID_DYNAMIC_TEXT, DisplayLongValue(nValue), %FALSE)
    ZD_SetObjectTextEx(%ID_DYNAMIC_CHORD, PitchToChord(nValue), %FALSE)
    ZD_SetObjectAngle(%ID_DYNAMIC_FRONT, TickToAngle(nValue), %FALSE)

    '// CustomMixes
    nValue = 100
	for K = 1 to %MAXCHANNEL - 1
        nID = %ID_THUMB_VERT + K - 1
        SetThumbVert(nID, %ID_THUMB_VERT, %ID_SLIDER_VERT, nValue)
    next

    '// LoadGain
    sValue = 1.0
    ZD_SetObjectTextEx(%ID_GAIN_LED, DisplayFloatValue(sValue), %FALSE)
    nPercent = sValue * 50
    ZD_SetObjectAngle(%ID_GAIN_FRONT, PercentageToAngle(nPercent), %FALSE)

    '// DynamicsAndUserLoop
    nPercent = 100: nDuration = 1750
    for K = 1 to %MAXCHANNEL
        if (K = %MAXCHANNEL) then
            ZD_SetObjectTextEx(%ID_VOL_LED_UL, DisplayLongValue(nPercent), %FALSE)
            ZD_SetObjectAngle(%ID_VOL_FRONT_UL, PercentageToAngle(nPercent), %FALSE)
            ZD_SetObjectTextEx(%ID_FADE_LED_UL, DisplayLongValue(nDuration), %FALSE)
            ZD_SetObjectAngle(%ID_FADE_FRONT_UL, PercentageToAngle(nDuration * 0.01), %FALSE)
        else
            nID = %ID_BTN_SWITCH + K - 1
            ZD_SetObjectFrameToUse(nID, 1, %FALSE)
        end if
    next
    ZD_SetObjectTextEx(%ID_VOL_LED, DisplayLongValue(nPercent), %FALSE)
    ZD_SetObjectAngle(%ID_VOL_FRONT, PercentageToAngle(nPercent), %FALSE)
    ZD_SetObjectTextEx(%ID_FADE_LED, DisplayLongValue(nDuration), %FALSE)
    ZD_SetObjectAngle(%ID_FADE_FRONT, PercentageToAngle(nDuration * 0.01), %FALSE)

    ZD_SetObjectFrameToUse(%ID_MIX_ENABLE, %OFF, %FALSE)
    ZD_SetObjectFrameToUse(%ID_DYN_ENABLE, %OFF, %TRUE)
end sub

sub ApiDoEvents (byval hWnd as DWORD)
    local msg AS tagMsg
    while PeekMessage(msg, %NULL, %NULL, %NULL, %PM_REMOVE)
         TranslateMessage(msg)
         DispatchMessage(msg)
    wend
end sub

function WndProc(byval hWnd as DWORD, byval uMsg as DWORD, byval wParam as DWORD, byval lParam as long) as long
    local ptNMHDR as NMHDR PTR
    local nID, nPercent, nTick, wmID, wmEvent, nListItem, nValue as long
    local sValue as single
    local hBitmap as DWORD
    static wasPercent, wasTick as long

    select case uMsg

    case %WM_GETMINMAXINFO 'Set minimum and naximum dialog size
         local MinMax as MINMAXINFO PTR
         MinMax = lParam
         @MinMax.ptMinTrackSize.x = MinTrackSizeW(0)
         @MinMax.ptMinTrackSize.y = MinTrackSizeH(0)
         function = 0: exit function

    case %WM_HSCROLL '// Slider/scrollbar horizontal control
         if (LO(INTEGER, wParam) = %SB_THUMBPOSITION) then
             nID = lParam
             nPercent = HI(INTEGER, wParam)
zTrace("ID" + STR$(nID) + " HSCROLL =" + STR$(nPercent))
             PlaySoundTrackbar()
             function = 0: exit function
         end if

    case %WM_VSCROLL '// Slider/scrollbar vertical control
         if (LO(INTEGER, wParam) = %SB_THUMBPOSITION) then
             nID = lParam
             nPercent = HI(INTEGER, wParam)
'zTrace("ID" + STR$(nID) + " VSCROLL =" + STR$(nPercent) + "%")
             ZD_SetObjectTextEx(nID + 10, DisplayLongValue(nPercent), %TRUE)
             PlaySoundTrackbar()
             function = 0: exit function
         end if

    case %WM_NOTIFY '// Gauge or Tick control
         ptNMHDR = lParam
         nID = wParam '// @ptNMHDR.idfrom
         if ((nID > %ID_GAUGE_BACK - 1) and (nID < %ID_GAUGE_LIGHT)) then
             nPercent = (((@ptNMHDR.code + 180) mod 360) / 360) * 100
             nValue = nPercent
             sValue = nPercent
             if (nID = %ID_FADE_FRONT or nID = %ID_FADE_FRONT_UL) then
                 nValue *= 100
             elseif (nID = %ID_GAIN_FRONT) then
                 sValue *= 0.02 '// Must be in the range 0 to 2, 1 being the default
             elseif (nID = %ID_TEMPO_FRONT) then
                 nValue -= 50
                 nValue*= 0.40
             end if
             if (nPercent <> wasPercent) then
zTrace("ID" + STR$(nID) + ", angle =" + STR$(@ptNMHDR.code) + "," + STR$(nPercent) + "%"+str$(sValue)+str$(nValue))
                 if (nID = %ID_GAIN_FRONT) then
                     ZD_SetObjectTextEx(nID + 20, DisplayFloatValue(sValue), %TRUE)
                 else
                     ZD_SetObjectTextEx(nID + 20, DisplayLongValue(nValue), %TRUE)
                 end if
'zTrace(STR$(GetDisplayLongValue(nID + 20)))
             end if
             wasPercent = nPercent
         elseif ((nID > %ID_TICK_BACK) and (nID < %ID_TICK_FRONT + (%ID_TICK_FRONT - %ID_TICK_BACK))) then
             nTick = @ptNMHDR.code
             if (nTick <> wasTick) then
zTrace("ID" + STR$(nID) + ", tick =" + STR$(nTick)+str$(nID + (%ID_TICK_TEXT - %ID_TICK_BACK)) + PitchToChord(nTick))
                 PlaySoundClick()
                 if (nID = %ID_DYNAMIC_FRONT) then
                     nValue = GetDisplayLongValue(%ID_PITCH_TEXT)
                     if ((nValue + nTick) > 3) then
                         nTick = 3 - nValue
                         PlaySoundBeep()
                         ZD_SetObjectAngle(nID, TickToAngle(nTick), %TRUE)
                     elseif ((nValue + nTick) < -3) then
                         nTick = -3 - nValue
                         PlaySoundBeep()
                         ZD_SetObjectAngle(nID, TickToAngle(nTick), %TRUE)
                     end if
                 end if
                 ZD_SetObjectTextEx(nID + (%ID_TICK_TEXT - %ID_TICK_FRONT), LTRIM$(STR$(nTick)), %FALSE)
                 ZD_SetObjectTextEx(nID + (%ID_TICK_CHORD - %ID_TICK_FRONT), PitchToChord(nTick), %TRUE)
             end if
             wasTick = nTick
         end if

    case %WM_COMMAND
         wmID = LO(INTEGER, wParam)
         wmEvent = HI(INTEGER, wParam)

         select case long wmID
         case %ID_LIST_ARRANGE
              if (wmEvent = %LBN_SELCHANGE) then
zTrace("%ID_LIST_ARRANGE "+ListGetText(gP.hList, 3))
              end if
         case %ID_MIX_ENABLE
zTrace("%ID_MIX_ENABLE"+str$(wmEvent))
              PlaySoundBlup()
         case %ID_DYN_ENABLE
zTrace("%ID_DYN_ENABLE"+str$(wmEvent))
              PlaySoundBlup()
         case %ID_BTN_RESET
zTrace("%ID_BTN_RESET")
              PlaySoundPush()
              ResetToDefault()
              ApiDoEvents(gP.imagectrl)
              skDialogInfo(GetCtrlText(gP.hMain), $CRLF + "Reset song to defaults done.", "")
         case %ID_BTN_APPLY
zTrace("%ID_BTN_APPLY")
              PlaySoundPush()

SaveTempoPitch()
SaveCustomMixes()
SaveGain()
SaveDynamicsAndUserLoop()
skDialogInfo(GetCtrlText(gP.hMain), $CRLF + "Song configuration has been saved.", "")

         case %ID_BTN_SELECT
zTrace("%ID_BTN_SELECT")
              PlaySoundPush()
zTrace(FileOpen(hWnd))
         case %ID_BTN_PAUSE
'zTrace("%ID_BTN_PAUSE")
              ZI_SetMouseOverObjectID(%ID_BTN_PLAY)
              ZD_SetObjectVisibility(%ID_BTN_PLAY, %ZS_VISIBLE)
              ZD_SetObjectFrameToUse(%ID_BTN_PLAY, 3, %TRUE)
              gP.overID = %ID_BTN_PLAY

              ZD_SetObjectFrameToUse(%ID_BTN_PAUSE, 1, %FALSE)
              ZD_ShowObject(%ID_BTN_PAUSE, %ZS_HIDDEN)
              PlaySoundPush()
              gP.playing = %FALSE              
         case %ID_BTN_PLAY
'zTrace("%ID_BTN_PLAY")
              ZI_SetMouseOverObjectID(%ID_BTN_PAUSE)
              ZD_SetObjectVisibility(%ID_BTN_PAUSE, %ZS_VISIBLE)
              ZD_SetObjectFrameToUse(%ID_BTN_PAUSE, 3, %TRUE)
              gP.overID = %ID_BTN_PAUSE

              ZD_SetObjectFrameToUse(%ID_BTN_PLAY, 1, %FALSE)
              ZD_ShowObject(%ID_BTN_PLAY, %ZS_HIDDEN)
              PlaySoundPush()
              gP.playing = %TRUE
         case %ID_BTN_ACOUSTIC
zTrace("%ID_BTN_ACOUSTIC"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_BASS
zTrace("%ID_BTN_BASS"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_DRUM
zTrace("%ID_BTN_DRUM"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_GUITAR
zTrace("%ID_BTN_GUITAR"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_KEY
zTrace("%ID_BTN_KEY"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_PERC
zTrace("%ID_BTN_PERC"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_PIANO
zTrace("%ID_BTN_PIANO"+str$(wmEvent))
              PlaySoundClick()
         case %ID_BTN_XTRACK
zTrace("%ID_BTN_XTRACK"+str$(wmEvent))
              PlaySoundClick()
         case %ID_LARROW
              nListItem = ListGetCursel(gP.hlistback)
              if (nListItem > 1) then
                  nListItem -= 1
              else 
                  nListItem = ListCount(gP.hlistback)
              end if
              ListSelectPlus(gP.hlistback, nListItem) 
              '// Create the background
              if (SetBackground()) then
                  gBin.backsize = FileSize(ListGetText(gP.hlistback, nListItem))
                  PlaySoundBlup()
                  ZI_UpdateWindow(gP.imagectrl, 0)
                  UpdateSkinBackground()
              end if
         case %ID_RARROW
              nListItem = ListGetCursel(gP.hlistback)
              if (nListItem < ListCount(gP.hlistback)) then
                  nListItem += 1
              else
                  nListItem = 1
              end if
              ListSelectPlus(gP.hlistback, nListItem)
              '// Create the background
              if (SetBackground()) then
                  gBin.backsize = FileSize(ListGetText(gP.hlistback, nListItem))
                  PlaySoundBlup()
                  ZI_UpdateWindow(gP.imagectrl, 0)
                  UpdateSkinBackground()
              end if
         end select

'    case %WM_TIMER
 '        RenderAnimation()

    case %WM_DESTROY
         PostQuitMessage(0)
         function = 0: exit function

    end select

    function = DefWindowProc(hWnd, uMsg, wParam, lParam)
end function

sub DetectPopupBackground()
    local nSelected as long, hFind as DWORD
    local fd as WIN32_FIND_DATA
    local szBackground as asciiz * %MAX_PATH

    if (gP.hlistback = 0) then
        gP.hlistback = CreateWindowExA(0, "LISTBOX", "", %WS_CHILD or %LBS_SORT, 0, 0, 0, 0, gP.hMain, 0, gP.hInstance, byval %NULL)
    else
        ListDeleteAll(gP.hlistback)
    end if

    PathCombine(gP.szresource, EXEresource(), "back*.png")
    hFind = FindFirstFile(gP.szresource, fd)
    if (hFind <> %INVALID_HANDLE_VALUE) then
        do 
            if (asc(fd.cFileName) <> 46) then
                select case long fd.dwFileAttributes
                case 0, 1, 32, 33, 128
                     PathCombine(gP.szresource, EXEresource(), fd.cFileName)
                     CharLowerA(gP.szresource)
                     if (ListAdd(gP.hlistback, gP.szresource) > -1) then
                         '// if (same size,) then we assume it is our current background...
                         if (fd.nFileSizeLow = gBin.backsize) then szBackground = gP.szresource
                     end if
                end select
            end if
        loop while (FindNextFile(hFind, fd))
        FindClose(hFind)
    end if
    nSelected = ListFindString(gP.hlistback, szBackground)
    if (nSelected < 1) then
        nSelected = 1
        gBin.backsize = FileSize(ListGetText(gP.hlistback, nSelected))
    end if
    ListSelectPlus(gP.hlistback, nSelected)
    skSkinDisable(gP.hlistback)
end sub

sub skSkinDisable(byval hCtrl as DWORD)
    local hProc as DWORD
    if (gP.winliftdll) then
        hPROC = GetProcAddress(gP.winliftdll, "skSkinDisable")
        if (hPROC) then CALL DWORD hPROC USING skSkinDisable(hCtrl)
    end if
end sub

function skInitEngine(zSkinFile as asciiz, zUserKey as asciiz) as long
    local hProc as DWORD, nRet as long
    if (gP.winliftdll) then
        hPROC = GetProcAddress(gP.winliftdll, "skInitEngine")
        if (hPROC) then CALL DWORD hPROC USING skInitEngine(zSkinFile, zUserKey) TO nRet
    end if
    function = nRet
end function

function skSkinWindow(byval hWnd as DWORD, zSysButTip as asciiz) as long
    local hProc as DWORD, nRet as long
    if (gP.winliftdll) then
        hPROC = GetProcAddress(gP.winliftdll, "skSkinWindow")
        if (hPROC) then CALL DWORD hPROC USING skSkinWindow(hWnd, zSysButTip) TO nRet
    end if
    function = nRet
end function

function skDialogInfo(szCaption as asciiz, szMessage as asciiz, szButtonText as asciiz) as long
    local hProc as DWORD, nRet as long
    if (gP.winliftdll) then
        hPROC = GetProcAddress(gP.winliftdll, "skDialogInfo")
        if (hPROC) then CALL DWORD hPROC USING skDialogInfo(szCaption, szMessage, szButtonText) TO nRet
    end if
    function = nRet
end function

function skSkinFolder() as string
    local hProc as DWORD, sRet as string
    if (gP.winliftdll) then
        hPROC = GetProcAddress(gP.winliftdll, "skSkinFolder")
        if (hPROC) then CALL DWORD hPROC USING skSkinFolder() TO sRet
    end if
    function = sRet
end function

function GetCtrlText(byval hCtrl as DWORD) as string
    local nLength as long, szText as asciiz * 4096
    nLength = GetWindowText(hCtrl, szText, sizeof(szText))
    if (nLength) then function = LEFT$(szText, nLength)
end function

function WinMain (byval hInstance as DWORD, byval hPrevInstance as DWORD, _
                  byval lpCmdLine as asciiz PTR, byval nCmdShow as long) as long

    local Msg     as tagMsg
    local wcx     as WndClassEx
    local szClass as asciiz * 16
    local hFound, hMutex, dwStyleEx, dwStyle, dwBytesWritten, hFile as DWORD
    local x, y, IsInitialized, bErrorFlag as long
    local szActiveSongPath as asciiz * %MAX_PATH
    szActiveSongPath = "C:\Toto\FlyStdPro5\Exe\Mono\Sweetly Broken (A)\"

    szClass = "ZSET32"

    '//hMutex = CreateMutex(byval %Null, 0, szClass)
    '//if (hMutex) then
    '//    if (GetLastError = %ERROR_ALREADY_EXISTS) then
    '//        do
    '//           hFound = FindWindow(szClass, ""): if hFound then exit do
    '//           while PeekMessage(Msg, %NULL, %NULL, %NULL, %PM_REMOVE): wend
    '//        loop
    '//        if IsIconic(hFound) then ShowWindow(hFound, %SW_RESTORE)
    '//        SetForeGroundWindow(hFound)
    '//        function = 0: exit function
    '//    end if
    '//end if

    gP.hInstance = hInstance
    wcx.cbSize = sizeof(WNDCLASSEX)
    IsInitialized = GetClassInfoEx(hInstance, szClass, wcx)
    if (IsInitialized     = 0) then
        wcx.style         = %CS_HREDRAW or %CS_VREDRAW
        wcx.lpfnWndProc   = CODEPTR(WndProc)
        wcx.cbClsExtra    = 0
        wcx.cbWndExtra    = 0
        wcx.hInstance     = hInstance
        wcx.hIcon         = %NULL
        wcx.hCursor       = LoadCursor(%NULL, byval %IDC_ARROW)
        wcx.hbrBackground = %COLOR_WINDOW + 1
        wcx.lpszMenuName  = %NULL
        wcx.lpszClassName = VARPTR(szClass)
        wcx.hIconSm       = wcx.hIcon
        if (RegisterClassEx(wcx)) then IsInitialized = -1
    end if

    if (IsInitialized) then
        local r as RECT
        dwStyleEx = 0
        dwStyle = %WS_POPUP or %WS_CAPTION or %WS_SYSMENU or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN
        '// Adjust the window to use the client size.
        SetRect(r, 0, 0, %ClientWidth, %ClientHeight)
        AdjustWindowRectEx(r, dwStyle, %FALSE, dwStyleEx)
        MinTrackSizeW(r.nRight - r.nLeft)
        MinTrackSizeH(r.nBottom - r.nTop)
        x = MAX&((GetSystemMetrics(%SM_CXSCREEN) - MinTrackSizeW(0)) \ 2, 0)
        y = MAX&((GetSystemMetrics(%SM_CYSCREEN) - MinTrackSizeH(0)) \ 2, 0)

        gP.szsongpath = szActiveSongPath
        local sPath, sSongName as string
        zSplitN(RTRIM$(szActiveSongPath, $ANTI), sPath, sSongName)

        '// The main window
        gP.hMain = CreateWindowExA(dwStyleEx, szClass, "Settings", _
                                   dwStyle, x, y, MinTrackSizeW(0), MinTrackSizeH(0), %NULL, %NULL, hInstance, byval %NULL)
        if (gP.hMain) then
            RegisterGDImageClass()

            '// Create the GDImage graphic control.
            dwStyle = %WS_CHILD or %WS_VISIBLE '// or %WS_CLIPSIBLINGS or %WS_CLIPCHILDREN
            gP.imagectrl = CreateWindowExA(0, $GDImageClassName, "", dwStyle, 0, 0, %ClientWidth, %ClientHeight, _
                           gP.hMain, %IDC_CTRL, hInstance, byval %NULL)
            '// Apply gradient to the background.
            ZI_SetProperty(gP.imagectrl, %ZI_GradientTop, RGB(64,64,64))
            ZI_SetProperty(gP.imagectrl, %ZI_GradientBottom, RGB(0,0,0))
            '// Anchor the conrol to full resize mode.
            ZI_SetAnchorMode(gP.imagectrl, %ANCHOR_HEIGHT_WIDTH)

            '// Read parameters
            PathCombine(gP.szresource, TEMPpath(), $SETFLY)
            if (zExist(gP.szresource)) then
                hFile = CreateFile(gP.szresource, %GENERIC_READ, 0, byval %NULL, %OPEN_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
                if (hFile <> %INVALID_HANDLE_VALUE) then 
                    bErrorFlag = ReadFile(hFile, byval VARPTR(gBin), sizeof(gBin), dwBytesWritten, byval %NULL)
                    CloseHandle(hFile)
                end if
            end if
            DetectPopupBackground()
            DetectArrangement(gP.szsongpath + "NewArrangement.car")

            gP.winliftdll = LoadLibrary("WinLIFT")
            if (gP.winliftdll) then
               if (gP.imagectrl) then
                   skSkinDisable(gP.hlistback) '// Do not skin listbox control.
                   skSkinDisable(gP.hlist)     '// Do not skin listbox control.
                   skSkinDisable(gP.imagectrl) '// Do not skin the main graphic control.
                   PathCombine(gP.szresource, EXEpath(), "Ampli.sks")
                   if skInitEngine(gP.szresource, $FLYWLFT) then
                       skSkinWindow(gP.hMain, "Dock|Undock|Minimize|Maximize|Restore|Close")
                   end if
               end if
            end if

            CreateControls()
            LoadTempoPitch()
            Loadcustommixes()
            LoadGain()
            LoadDynamicsAndUserLoop()
            SetPlayPercentage(0)

            '// Show main window
            ShowWindow(gP.hMain, nCmdShow)
            SetForegroundWindow(gP.hMain)                  '// Slightly Higher Priority
            SetFocus(gP.imagectrl)                         '// Sets Keyboard Focus To The Window

            '//SetTimer(gP.hMain, %IDC_TIMER, 33, %NULL)
            while GetMessage(Msg, %NULL, 0, 0)
                  TranslateMessage(msg)                    '// Translate The Message
                  DispatchMessage(msg)                     '// Dispatch The Message
            wend
            '//KillTimer(gP.hMain, %IDC_TIMER)

            '// We must reset ALL the global properties
            gP.hMain      = 0
            gP.hList      = 0
            gP.hlistback  = 0
            gP.imagectrl  = 0
            gP.hInstance  = 0
            gP.focusID    = 0
            gP.pushID     = 0
            gP.overID     = 0
            gP.seedangle  = 0
            gP.prevangle  = 0
            gP.wasangle   = 0
            gP.playing    = 0
            gP.usechan    = 0
            gP.chanlength = 0
            gP.szresource = ""
            gP.szsongpath = ""
            'gP.szexepath  = ""
            if (gP.winliftdll) then
                FreeLibrary(gP.winliftdll): gP.winliftdll = 0
            end if

            function = msg.wParam
         end if

    end if

    '//if (hMutex) then CloseHandle(hMutex)

    '// Save parameters
    PathCombine(gP.szresource, TEMPpath(), $SETFLY)
    hFile = CreateFile(gP.szresource, %GENERIC_WRITE, 0, byval %NULL, %CREATE_ALWAYS, %FILE_ATTRIBUTE_NORMAL, byval %NULL)
    if (hFile <> %INVALID_HANDLE_VALUE) then
        bErrorFlag = WriteFile(hFile, byval VARPTR(gBin), sizeof(gBin), dwBytesWritten, byval %NULL)
        CloseHandle(hFile)
    end if

end function
